/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2015 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
/**
@license
mersenne-twister.js - https://gist.github.com/banksean/300494

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

!function(){define("Core/defined",[],function(){"use strict";var t=function(t){return void 0!==t};return t}),define("Core/freezeObject",["./defined"],function(t){"use strict";var r=Object.freeze;return t(r)||(r=function(t){return t}),r}),define("Core/defaultValue",["./freezeObject"],function(t){"use strict";var r=function(t,r){return void 0!==t?t:r};return r.EMPTY_OBJECT=t({}),r}),define("Core/DeveloperError",["./defined"],function(t){"use strict";var r=function(t){this.name="DeveloperError",this.message=t;var r;try{throw new Error}catch(e){r=e.stack}this.stack=r};return r.prototype.toString=function(){var r=this.name+": "+this.message;return t(this.stack)&&(r+="\n"+this.stack.toString()),r},r.throwInstantiationError=function(){throw new r("This function defines an interface and should not be called directly.")},r}),define("ThirdParty/mersenne-twister",[],function(){var t=function(t){void 0==t&&(t=(new Date).getTime()),this.N=624,this.M=397,this.MATRIX_A=2567483615,this.UPPER_MASK=2147483648,this.LOWER_MASK=2147483647,this.mt=new Array(this.N),this.mti=this.N+1,this.init_genrand(t)};return t.prototype.init_genrand=function(t){for(this.mt[0]=t>>>0,this.mti=1;this.mti<this.N;this.mti++){var t=this.mt[this.mti-1]^this.mt[this.mti-1]>>>30;this.mt[this.mti]=(1812433253*((4294901760&t)>>>16)<<16)+1812433253*(65535&t)+this.mti,this.mt[this.mti]>>>=0}},t.prototype.genrand_int32=function(){var t,r=new Array(0,this.MATRIX_A);if(this.mti>=this.N){var e;for(this.mti==this.N+1&&this.init_genrand(5489),e=0;e<this.N-this.M;e++)t=this.mt[e]&this.UPPER_MASK|this.mt[e+1]&this.LOWER_MASK,this.mt[e]=this.mt[e+this.M]^t>>>1^r[1&t];for(;e<this.N-1;e++)t=this.mt[e]&this.UPPER_MASK|this.mt[e+1]&this.LOWER_MASK,this.mt[e]=this.mt[e+(this.M-this.N)]^t>>>1^r[1&t];t=this.mt[this.N-1]&this.UPPER_MASK|this.mt[0]&this.LOWER_MASK,this.mt[this.N-1]=this.mt[this.M-1]^t>>>1^r[1&t],this.mti=0}return t=this.mt[this.mti++],t^=t>>>11,t^=2636928640&t<<7,t^=4022730752&t<<15,t^=t>>>18,t>>>0},t.prototype.random=function(){return this.genrand_int32()*(1/4294967296)},t}),define("Core/Math",["../ThirdParty/mersenne-twister","./defaultValue","./defined","./DeveloperError"],function(t,r){"use strict";var e={};e.EPSILON1=.1,e.EPSILON2=.01,e.EPSILON3=.001,e.EPSILON4=1e-4,e.EPSILON5=1e-5,e.EPSILON6=1e-6,e.EPSILON7=1e-7,e.EPSILON8=1e-8,e.EPSILON9=1e-9,e.EPSILON10=1e-10,e.EPSILON11=1e-11,e.EPSILON12=1e-12,e.EPSILON13=1e-13,e.EPSILON14=1e-14,e.EPSILON15=1e-15,e.EPSILON16=1e-16,e.EPSILON17=1e-17,e.EPSILON18=1e-18,e.EPSILON19=1e-19,e.EPSILON20=1e-20,e.GRAVITATIONALPARAMETER=3986004418e5,e.SOLAR_RADIUS=6955e5,e.LUNAR_RADIUS=1737400,e.SIXTY_FOUR_KILOBYTES=65536,e.sign=function(t){return t>0?1:0>t?-1:0},e.signNotZero=function(t){return 0>t?-1:1},e.toSNorm=function(t){return Math.round(255*(.5*e.clamp(t,-1,1)+.5))},e.fromSNorm=function(t){return 2*(e.clamp(t,0,255)/255)-1},e.sinh=function(t){var r=Math.pow(Math.E,t),e=Math.pow(Math.E,-1*t);return.5*(r-e)},e.cosh=function(t){var r=Math.pow(Math.E,t),e=Math.pow(Math.E,-1*t);return.5*(r+e)},e.lerp=function(t,r,e){return(1-e)*t+e*r},e.PI=Math.PI,e.ONE_OVER_PI=1/Math.PI,e.PI_OVER_TWO=.5*Math.PI,e.PI_OVER_THREE=Math.PI/3,e.PI_OVER_FOUR=Math.PI/4,e.PI_OVER_SIX=Math.PI/6,e.THREE_PI_OVER_TWO=.5*3*Math.PI,e.TWO_PI=2*Math.PI,e.ONE_OVER_TWO_PI=1/(2*Math.PI),e.RADIANS_PER_DEGREE=Math.PI/180,e.DEGREES_PER_RADIAN=180/Math.PI,e.RADIANS_PER_ARCSECOND=e.RADIANS_PER_DEGREE/3600,e.toRadians=function(t){return t*e.RADIANS_PER_DEGREE},e.toDegrees=function(t){return t*e.DEGREES_PER_RADIAN},e.convertLongitudeRange=function(t){var r=e.TWO_PI,n=t-Math.floor(t/r)*r;return n<-Math.PI?n+r:n>=Math.PI?n-r:n},e.negativePiToPi=function(t){return e.zeroToTwoPi(t+e.PI)-e.PI},e.zeroToTwoPi=function(t){var r=e.mod(t,e.TWO_PI);return Math.abs(r)<e.EPSILON14&&Math.abs(t)>e.EPSILON14?e.TWO_PI:r},e.mod=function(t,r){return(t%r+r)%r},e.equalsEpsilon=function(t,e,n,o){o=r(o,n);var i=Math.abs(t-e);return o>=i||i<=n*Math.max(Math.abs(t),Math.abs(e))};var n=[1];e.factorial=function(t){var r=n.length;if(t>=r)for(var e=n[r-1],o=r;t>=o;o++)n.push(e*o);return n[t]},e.incrementWrap=function(t,e,n){return n=r(n,0),++t,t>e&&(t=n),t},e.isPowerOfTwo=function(t){return 0!==t&&0===(t&t-1)},e.nextPowerOfTwo=function(t){return--t,t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,t|=t>>16,++t,t},e.clamp=function(t,r,e){return r>t?r:t>e?e:t};var o=new t;return e.setRandomNumberSeed=function(r){o=new t(r)},e.nextRandomNumber=function(){return o.random()},e.acosClamped=function(t){return Math.acos(e.clamp(t,-1,1))},e.asinClamped=function(t){return Math.asin(e.clamp(t,-1,1))},e.chordLength=function(t,r){return 2*r*Math.sin(.5*t)},e}),define("Core/Cartesian3",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,r,e,n,o){"use strict";var i=function(r,e,n){this.x=t(r,0),this.y=t(e,0),this.z=t(n,0)};i.fromSpherical=function(e,n){r(n)||(n=new i);var o=e.clock,a=e.cone,s=t(e.magnitude,1),u=s*Math.sin(a);return n.x=u*Math.cos(o),n.y=u*Math.sin(o),n.z=s*Math.cos(a),n},i.fromElements=function(t,e,n,o){return r(o)?(o.x=t,o.y=e,o.z=n,o):new i(t,e,n)},i.clone=function(t,e){return r(t)?r(e)?(e.x=t.x,e.y=t.y,e.z=t.z,e):new i(t.x,t.y,t.z):void 0},i.fromCartesian4=i.clone,i.packedLength=3,i.pack=function(r,e,n){n=t(n,0),e[n++]=r.x,e[n++]=r.y,e[n]=r.z},i.unpack=function(e,n,o){return n=t(n,0),r(o)||(o=new i),o.x=e[n++],o.y=e[n++],o.z=e[n],o},i.fromArray=i.unpack,i.maximumComponent=function(t){return Math.max(t.x,t.y,t.z)},i.minimumComponent=function(t){return Math.min(t.x,t.y,t.z)},i.minimumByComponent=function(t,r,e){return e.x=Math.min(t.x,r.x),e.y=Math.min(t.y,r.y),e.z=Math.min(t.z,r.z),e},i.maximumByComponent=function(t,r,e){return e.x=Math.max(t.x,r.x),e.y=Math.max(t.y,r.y),e.z=Math.max(t.z,r.z),e},i.magnitudeSquared=function(t){return t.x*t.x+t.y*t.y+t.z*t.z},i.magnitude=function(t){return Math.sqrt(i.magnitudeSquared(t))};var a=new i;i.distance=function(t,r){return i.subtract(t,r,a),i.magnitude(a)},i.distanceSquared=function(t,r){return i.subtract(t,r,a),i.magnitudeSquared(a)},i.normalize=function(t,r){var e=i.magnitude(t);return r.x=t.x/e,r.y=t.y/e,r.z=t.z/e,r},i.dot=function(t,r){return t.x*r.x+t.y*r.y+t.z*r.z},i.multiplyComponents=function(t,r,e){return e.x=t.x*r.x,e.y=t.y*r.y,e.z=t.z*r.z,e},i.add=function(t,r,e){return e.x=t.x+r.x,e.y=t.y+r.y,e.z=t.z+r.z,e},i.subtract=function(t,r,e){return e.x=t.x-r.x,e.y=t.y-r.y,e.z=t.z-r.z,e},i.multiplyByScalar=function(t,r,e){return e.x=t.x*r,e.y=t.y*r,e.z=t.z*r,e},i.divideByScalar=function(t,r,e){return e.x=t.x/r,e.y=t.y/r,e.z=t.z/r,e},i.negate=function(t,r){return r.x=-t.x,r.y=-t.y,r.z=-t.z,r},i.abs=function(t,r){return r.x=Math.abs(t.x),r.y=Math.abs(t.y),r.z=Math.abs(t.z),r};var s=new i;i.lerp=function(t,r,e,n){return i.multiplyByScalar(r,e,s),n=i.multiplyByScalar(t,1-e,n),i.add(s,n,n)};var u=new i,l=new i;i.angleBetween=function(t,r){i.normalize(t,u),i.normalize(r,l);var e=i.dot(u,l),n=i.magnitude(i.cross(u,l,u));return Math.atan2(n,e)};var c=new i;i.mostOrthogonalAxis=function(t,r){var e=i.normalize(t,c);return i.abs(e,e),r=e.x<=e.y?e.x<=e.z?i.clone(i.UNIT_X,r):i.clone(i.UNIT_Z,r):e.y<=e.z?i.clone(i.UNIT_Y,r):i.clone(i.UNIT_Z,r)},i.equals=function(t,e){return t===e||r(t)&&r(e)&&t.x===e.x&&t.y===e.y&&t.z===e.z},i.equalsArray=function(t,r,e){return t.x===r[e]&&t.y===r[e+1]&&t.z===r[e+2]},i.equalsEpsilon=function(t,e,n,i){return t===e||r(t)&&r(e)&&o.equalsEpsilon(t.x,e.x,n,i)&&o.equalsEpsilon(t.y,e.y,n,i)&&o.equalsEpsilon(t.z,e.z,n,i)},i.cross=function(t,r,e){var n=t.x,o=t.y,i=t.z,a=r.x,s=r.y,u=r.z,l=o*u-i*s,c=i*a-n*u,E=n*s-o*a;return e.x=l,e.y=c,e.z=E,e},i.fromDegrees=function(t,r,e,n,a){var s=o.toRadians(t),u=o.toRadians(r);return i.fromRadians(s,u,e,n,a)};var E=new i,f=new i,h=new i(40680631590769,40680631590769,40408299984661.445);return i.fromRadians=function(e,n,o,a,s){o=t(o,0);var u=r(a)?a.radiiSquared:h,l=Math.cos(n);E.x=l*Math.cos(e),E.y=l*Math.sin(e),E.z=Math.sin(n),E=i.normalize(E,E),i.multiplyComponents(u,E,f);var c=Math.sqrt(i.dot(E,f));return f=i.divideByScalar(f,c,f),E=i.multiplyByScalar(E,o,E),r(s)||(s=new i),i.add(f,E,s)},i.fromDegreesArray=function(t,r,e){for(var n=new Array(t.length),a=0;a<t.length;a++)n[a]=o.toRadians(t[a]);return i.fromRadiansArray(n,r,e)},i.fromRadiansArray=function(t,e,n){var o=t.length;r(n)?n.length=o/2:n=new Array(o/2);for(var a=0;o>a;a+=2){var s=t[a],u=t[a+1];n[a/2]=i.fromRadians(s,u,0,e,n[a/2])}return n},i.fromDegreesArrayHeights=function(t,r,e){for(var n=new Array(t.length),a=0;a<t.length;a+=3)n[a]=o.toRadians(t[a]),n[a+1]=o.toRadians(t[a+1]),n[a+2]=t[a+2];return i.fromRadiansArrayHeights(n,r,e)},i.fromRadiansArrayHeights=function(t,e,n){var o=t.length;r(n)?n.length=o/3:n=new Array(o/3);for(var a=0;o>a;a+=3){var s=t[a],u=t[a+1],l=t[a+2];n[a/3]=i.fromRadians(s,u,l,e,n[a/3])}return n},i.ZERO=n(new i(0,0,0)),i.UNIT_X=n(new i(1,0,0)),i.UNIT_Y=n(new i(0,1,0)),i.UNIT_Z=n(new i(0,0,1)),i.prototype.clone=function(t){return i.clone(this,t)},i.prototype.equals=function(t){return i.equals(this,t)},i.prototype.equalsEpsilon=function(t,r,e){return i.equalsEpsilon(this,t,r,e)},i.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+")"},i}),define("Core/Cartographic",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,r,e,n,o){"use strict";var i=function(r,e,n){this.longitude=t(r,0),this.latitude=t(e,0),this.height=t(n,0)};return i.fromRadians=function(e,n,o,a){return o=t(o,0),r(a)?(a.longitude=e,a.latitude=n,a.height=o,a):new i(e,n,o)},i.fromDegrees=function(t,r,e,n){return t=o.toRadians(t),r=o.toRadians(r),i.fromRadians(t,r,e,n)},i.clone=function(t,e){return r(t)?r(e)?(e.longitude=t.longitude,e.latitude=t.latitude,e.height=t.height,e):new i(t.longitude,t.latitude,t.height):void 0},i.equals=function(t,e){return t===e||r(t)&&r(e)&&t.longitude===e.longitude&&t.latitude===e.latitude&&t.height===e.height},i.equalsEpsilon=function(t,e,n){return t===e||r(t)&&r(e)&&Math.abs(t.longitude-e.longitude)<=n&&Math.abs(t.latitude-e.latitude)<=n&&Math.abs(t.height-e.height)<=n},i.ZERO=n(new i(0,0,0)),i.prototype.clone=function(t){return i.clone(this,t)},i.prototype.equals=function(t){return i.equals(this,t)},i.prototype.equalsEpsilon=function(t,r){return i.equalsEpsilon(this,t,r)},i.prototype.toString=function(){return"("+this.longitude+", "+this.latitude+", "+this.height+")"},i}),define("Core/defineProperties",["./defined"],function(t){"use strict";var r=function(){try{return"x"in Object.defineProperty({},"x",{})}catch(t){return!1}}(),e=Object.defineProperties;return r&&t(e)||(e=function(t){return t}),e}),define("Core/Ellipsoid",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math"],function(t,r,e,n,o,i,a,s){"use strict";function u(r,n,o,i){n=e(n,0),o=e(o,0),i=e(i,0),r._radii=new t(n,o,i),r._radiiSquared=new t(n*n,o*o,i*i),r._radiiToTheFourth=new t(n*n*n*n,o*o*o*o,i*i*i*i),r._oneOverRadii=new t(0===n?0:1/n,0===o?0:1/o,0===i?0:1/i),r._oneOverRadiiSquared=new t(0===n?0:1/(n*n),0===o?0:1/(o*o),0===i?0:1/(i*i)),r._minimumRadius=Math.min(n,o,i),r._maximumRadius=Math.max(n,o,i),r._centerToleranceSquared=s.EPSILON1}var l=function(t,r,e){this._radii=void 0,this._radiiSquared=void 0,this._radiiToTheFourth=void 0,this._oneOverRadii=void 0,this._oneOverRadiiSquared=void 0,this._minimumRadius=void 0,this._maximumRadius=void 0,this._centerToleranceSquared=void 0,u(this,t,r,e)};o(l.prototype,{radii:{get:function(){return this._radii}},radiiSquared:{get:function(){return this._radiiSquared}},radiiToTheFourth:{get:function(){return this._radiiToTheFourth}},oneOverRadii:{get:function(){return this._oneOverRadii}},oneOverRadiiSquared:{get:function(){return this._oneOverRadiiSquared}},minimumRadius:{get:function(){return this._minimumRadius}},maximumRadius:{get:function(){return this._maximumRadius}}}),l.clone=function(r,e){if(!n(r))return void 0;var o=r._radii;return n(e)?(t.clone(o,e._radii),t.clone(r._radiiSquared,e._radiiSquared),t.clone(r._radiiToTheFourth,e._radiiToTheFourth),t.clone(r._oneOverRadii,e._oneOverRadii),t.clone(r._oneOverRadiiSquared,e._oneOverRadiiSquared),e._minimumRadius=r._minimumRadius,e._maximumRadius=r._maximumRadius,e._centerToleranceSquared=r._centerToleranceSquared,e):new l(o.x,o.y,o.z)},l.fromCartesian3=function(t,r){return n(r)||(r=new l),n(t)?(u(r,t.x,t.y,t.z),r):r},l.WGS84=a(new l(6378137,6378137,6356752.314245179)),l.UNIT_SPHERE=a(new l(1,1,1)),l.MOON=a(new l(s.LUNAR_RADIUS,s.LUNAR_RADIUS,s.LUNAR_RADIUS)),l.prototype.clone=function(t){return l.clone(this,t)},l.packedLength=t.packedLength,l.pack=function(r,n,o){o=e(o,0),t.pack(r._radii,n,o)},l.unpack=function(r,n,o){n=e(n,0);var i=t.unpack(r,n);return l.fromCartesian3(i,o)},l.prototype.geocentricSurfaceNormal=t.normalize,l.prototype.geodeticSurfaceNormalCartographic=function(r,e){var o=r.longitude,i=r.latitude,a=Math.cos(i),s=a*Math.cos(o),u=a*Math.sin(o),l=Math.sin(i);return n(e)||(e=new t),e.x=s,e.y=u,e.z=l,t.normalize(e,e)},l.prototype.geodeticSurfaceNormal=function(r,e){return n(e)||(e=new t),e=t.multiplyComponents(r,this._oneOverRadiiSquared,e),t.normalize(e,e)};var c=new t,E=new t;l.prototype.cartographicToCartesian=function(r,e){var o=c,i=E;this.geodeticSurfaceNormalCartographic(r,o),t.multiplyComponents(this._radiiSquared,o,i);var a=Math.sqrt(t.dot(o,i));return t.divideByScalar(i,a,i),t.multiplyByScalar(o,r.height,o),n(e)||(e=new t),t.add(i,o,e)},l.prototype.cartographicArrayToCartesianArray=function(t,r){var e=t.length;n(r)?r.length=e:r=new Array(e);for(var o=0;e>o;o++)r[o]=this.cartographicToCartesian(t[o],r[o]);return r};var f=new t,h=new t,d=new t;l.prototype.cartesianToCartographic=function(e,o){var i=this.scaleToGeodeticSurface(e,h);if(!n(i))return void 0;var a=this.geodeticSurfaceNormal(i,f),u=t.subtract(e,i,d),l=Math.atan2(a.y,a.x),c=Math.asin(a.z),E=s.sign(t.dot(u,e))*t.magnitude(u);return n(o)?(o.longitude=l,o.latitude=c,o.height=E,o):new r(l,c,E)},l.prototype.cartesianArrayToCartographicArray=function(t,r){var e=t.length;n(r)?r.length=e:r=new Array(e);for(var o=0;e>o;++o)r[o]=this.cartesianToCartographic(t[o],r[o]);return r};var m=new t,T=new t;return l.prototype.scaleToGeodeticSurface=function(r,e){var o=r.x,i=r.y,a=r.z,u=this._oneOverRadii,l=u.x,c=u.y,E=u.z,f=o*o*l*l,h=i*i*c*c,d=a*a*E*E,R=f+h+d,p=Math.sqrt(1/R),S=t.multiplyByScalar(r,p,m);if(R<this._centerToleranceSquared)return isFinite(p)?t.clone(S,e):void 0;var _=this._oneOverRadiiSquared,A=_.x,C=_.y,g=_.z,y=T;y.x=2*S.x*A,y.y=2*S.y*C,y.z=2*S.z*g;var N,v,I,O,M,L,w,F,P,D,U,x=(1-p)*t.magnitude(r)/(.5*t.magnitude(y)),B=0;do{x-=B,I=1/(1+x*A),O=1/(1+x*C),M=1/(1+x*g),L=I*I,w=O*O,F=M*M,P=L*I,D=w*O,U=F*M,N=f*L+h*w+d*F-1,v=f*P*A+h*D*C+d*U*g;var b=-2*v;B=N/b}while(Math.abs(N)>s.EPSILON12);return n(e)?(e.x=o*I,e.y=i*O,e.z=a*M,e):new t(o*I,i*O,a*M)},l.prototype.scaleToGeocentricSurface=function(r,e){n(e)||(e=new t);var o=r.x,i=r.y,a=r.z,s=this._oneOverRadiiSquared,u=1/Math.sqrt(o*o*s.x+i*i*s.y+a*a*s.z);return t.multiplyByScalar(r,u,e)},l.prototype.transformPositionToScaledSpace=function(r,e){return n(e)||(e=new t),t.multiplyComponents(r,this._oneOverRadii,e)},l.prototype.transformPositionFromScaledSpace=function(r,e){return n(e)||(e=new t),t.multiplyComponents(r,this._radii,e)},l.prototype.equals=function(r){return this===r||n(r)&&t.equals(this._radii,r._radii)},l.prototype.toString=function(){return this._radii.toString()},l}),define("Core/deprecationWarning",["./defined","./DeveloperError"],function(t){"use strict";var r={},e=function(e,n){t(r[e])||(r[e]=!0,console.log(n))};return e}),define("Core/GeographicProjection",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid"],function(t,r,e,n,o,i,a){"use strict";var s=function(t){this._ellipsoid=e(t,a.WGS84),this._semimajorAxis=this._ellipsoid.maximumRadius,this._oneOverSemimajorAxis=1/this._semimajorAxis};return o(s.prototype,{ellipsoid:{get:function(){return this._ellipsoid}}}),s.prototype.project=function(r,e){var o=this._semimajorAxis,i=r.longitude*o,a=r.latitude*o,s=r.height;return n(e)?(e.x=i,e.y=a,e.z=s,e):new t(i,a,s)},s.prototype.unproject=function(t,e){var o=this._oneOverSemimajorAxis,i=t.x*o,a=t.y*o,s=t.z;return n(e)?(e.longitude=i,e.latitude=a,e.height=s,e):new r(i,a,s)},s}),define("Core/Intersect",["./freezeObject"],function(t){"use strict";var r={OUTSIDE:-1,INTERSECTING:0,INSIDE:1};return t(r)}),define("Core/Interval",["./defaultValue"],function(t){"use strict";var r=function(r,e){this.start=t(r,0),this.stop=t(e,0)};return r}),define("Core/Cartesian4",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,r,e,n,o){"use strict";var i=function(r,e,n,o){this.x=t(r,0),this.y=t(e,0),this.z=t(n,0),this.w=t(o,0)};i.fromElements=function(t,e,n,o,a){return r(a)?(a.x=t,a.y=e,a.z=n,a.w=o,a):new i(t,e,n,o)},i.fromColor=function(t,e){return r(e)?(e.x=t.red,e.y=t.green,e.z=t.blue,e.w=t.alpha,e):new i(t.red,t.green,t.blue,t.alpha)},i.clone=function(t,e){return r(t)?r(e)?(e.x=t.x,e.y=t.y,e.z=t.z,e.w=t.w,e):new i(t.x,t.y,t.z,t.w):void 0},i.packedLength=4,i.pack=function(r,e,n){n=t(n,0),e[n++]=r.x,e[n++]=r.y,e[n++]=r.z,e[n]=r.w},i.unpack=function(e,n,o){return n=t(n,0),r(o)||(o=new i),o.x=e[n++],o.y=e[n++],o.z=e[n++],o.w=e[n],o},i.fromArray=i.unpack,i.maximumComponent=function(t){return Math.max(t.x,t.y,t.z,t.w)},i.minimumComponent=function(t){return Math.min(t.x,t.y,t.z,t.w)},i.minimumByComponent=function(t,r,e){return e.x=Math.min(t.x,r.x),e.y=Math.min(t.y,r.y),e.z=Math.min(t.z,r.z),e.w=Math.min(t.w,r.w),e},i.maximumByComponent=function(t,r,e){return e.x=Math.max(t.x,r.x),e.y=Math.max(t.y,r.y),e.z=Math.max(t.z,r.z),e.w=Math.max(t.w,r.w),e},i.magnitudeSquared=function(t){return t.x*t.x+t.y*t.y+t.z*t.z+t.w*t.w},i.magnitude=function(t){return Math.sqrt(i.magnitudeSquared(t))};var a=new i;i.distance=function(t,r){return i.subtract(t,r,a),i.magnitude(a)},i.distanceSquared=function(t,r){return i.subtract(t,r,a),i.magnitudeSquared(a)},i.normalize=function(t,r){var e=i.magnitude(t);return r.x=t.x/e,r.y=t.y/e,r.z=t.z/e,r.w=t.w/e,r},i.dot=function(t,r){return t.x*r.x+t.y*r.y+t.z*r.z+t.w*r.w},i.multiplyComponents=function(t,r,e){return e.x=t.x*r.x,e.y=t.y*r.y,e.z=t.z*r.z,e.w=t.w*r.w,e},i.add=function(t,r,e){return e.x=t.x+r.x,e.y=t.y+r.y,e.z=t.z+r.z,e.w=t.w+r.w,e},i.subtract=function(t,r,e){return e.x=t.x-r.x,e.y=t.y-r.y,e.z=t.z-r.z,e.w=t.w-r.w,e},i.multiplyByScalar=function(t,r,e){return e.x=t.x*r,e.y=t.y*r,e.z=t.z*r,e.w=t.w*r,e},i.divideByScalar=function(t,r,e){return e.x=t.x/r,e.y=t.y/r,e.z=t.z/r,e.w=t.w/r,e},i.negate=function(t,r){return r.x=-t.x,r.y=-t.y,r.z=-t.z,r.w=-t.w,r},i.abs=function(t,r){return r.x=Math.abs(t.x),r.y=Math.abs(t.y),r.z=Math.abs(t.z),r.w=Math.abs(t.w),r};var s=new i;i.lerp=function(t,r,e,n){return i.multiplyByScalar(r,e,s),n=i.multiplyByScalar(t,1-e,n),i.add(s,n,n)};var u=new i;return i.mostOrthogonalAxis=function(t,r){var e=i.normalize(t,u);return i.abs(e,e),r=e.x<=e.y?e.x<=e.z?e.x<=e.w?i.clone(i.UNIT_X,r):i.clone(i.UNIT_W,r):e.z<=e.w?i.clone(i.UNIT_Z,r):i.clone(i.UNIT_W,r):e.y<=e.z?e.y<=e.w?i.clone(i.UNIT_Y,r):i.clone(i.UNIT_W,r):e.z<=e.w?i.clone(i.UNIT_Z,r):i.clone(i.UNIT_W,r)},i.equals=function(t,e){return t===e||r(t)&&r(e)&&t.x===e.x&&t.y===e.y&&t.z===e.z&&t.w===e.w},i.equalsArray=function(t,r,e){return t.x===r[e]&&t.y===r[e+1]&&t.z===r[e+2]&&t.w===r[e+3]},i.equalsEpsilon=function(t,e,n,i){return t===e||r(t)&&r(e)&&o.equalsEpsilon(t.x,e.x,n,i)&&o.equalsEpsilon(t.y,e.y,n,i)&&o.equalsEpsilon(t.z,e.z,n,i)&&o.equalsEpsilon(t.w,e.w,n,i)},i.ZERO=n(new i(0,0,0,0)),i.UNIT_X=n(new i(1,0,0,0)),i.UNIT_Y=n(new i(0,1,0,0)),i.UNIT_Z=n(new i(0,0,1,0)),i.UNIT_W=n(new i(0,0,0,1)),i.prototype.clone=function(t){return i.clone(this,t)},i.prototype.equals=function(t){return i.equals(this,t)},i.prototype.equalsEpsilon=function(t,r,e){return i.equalsEpsilon(this,t,r,e)},i.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+", "+this.w+")"},i}),define("Core/Matrix3",["./Cartesian3","./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,r,e,n,o,i){"use strict";function a(t){for(var r=0,e=0;9>e;++e){var n=t[e];r+=n*n}return Math.sqrt(r)}function s(t){for(var r=0,e=0;3>e;++e){var n=t[l.getElementIndex(h[e],f[e])];r+=2*n*n}return Math.sqrt(r)}function u(t,r){for(var e=i.EPSILON15,n=0,o=1,a=0;3>a;++a){var s=Math.abs(t[l.getElementIndex(h[a],f[a])]);s>n&&(o=a,n=s)}var u=1,c=0,E=f[o],d=h[o];if(Math.abs(t[l.getElementIndex(d,E)])>e){var m,T=t[l.getElementIndex(d,d)],R=t[l.getElementIndex(E,E)],p=t[l.getElementIndex(d,E)],S=(T-R)/2/p;m=0>S?-1/(-S+Math.sqrt(1+S*S)):1/(S+Math.sqrt(1+S*S)),u=1/Math.sqrt(1+m*m),c=m*u}return r=l.clone(l.IDENTITY,r),r[l.getElementIndex(E,E)]=r[l.getElementIndex(d,d)]=u,r[l.getElementIndex(d,E)]=c,r[l.getElementIndex(E,d)]=-c,r}var l=function(t,e,n,o,i,a,s,u,l){this[0]=r(t,0),this[1]=r(o,0),this[2]=r(s,0),this[3]=r(e,0),this[4]=r(i,0),this[5]=r(u,0),this[6]=r(n,0),this[7]=r(a,0),this[8]=r(l,0)};l.packedLength=9,l.pack=function(t,e,n){n=r(n,0),e[n++]=t[0],e[n++]=t[1],e[n++]=t[2],e[n++]=t[3],e[n++]=t[4],e[n++]=t[5],e[n++]=t[6],e[n++]=t[7],e[n++]=t[8]},l.unpack=function(t,n,o){return n=r(n,0),e(o)||(o=new l),o[0]=t[n++],o[1]=t[n++],o[2]=t[n++],o[3]=t[n++],o[4]=t[n++],o[5]=t[n++],o[6]=t[n++],o[7]=t[n++],o[8]=t[n++],o},l.clone=function(t,r){return e(t)?e(r)?(r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r[8]=t[8],r):new l(t[0],t[3],t[6],t[1],t[4],t[7],t[2],t[5],t[8]):void 0},l.fromArray=function(t,n,o){return n=r(n,0),e(o)||(o=new l),o[0]=t[n],o[1]=t[n+1],o[2]=t[n+2],o[3]=t[n+3],o[4]=t[n+4],o[5]=t[n+5],o[6]=t[n+6],o[7]=t[n+7],o[8]=t[n+8],o},l.fromColumnMajorArray=function(t,r){return l.clone(t,r)},l.fromRowMajorArray=function(t,r){return e(r)?(r[0]=t[0],r[1]=t[3],r[2]=t[6],r[3]=t[1],r[4]=t[4],r[5]=t[7],r[6]=t[2],r[7]=t[5],r[8]=t[8],r):new l(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8])},l.fromQuaternion=function(t,r){var n=t.x*t.x,o=t.x*t.y,i=t.x*t.z,a=t.x*t.w,s=t.y*t.y,u=t.y*t.z,c=t.y*t.w,E=t.z*t.z,f=t.z*t.w,h=t.w*t.w,d=n-s-E+h,m=2*(o-f),T=2*(i+c),R=2*(o+f),p=-n+s-E+h,S=2*(u-a),_=2*(i-c),A=2*(u+a),C=-n-s+E+h;return e(r)?(r[0]=d,r[1]=R,r[2]=_,r[3]=m,r[4]=p,r[5]=A,r[6]=T,r[7]=S,r[8]=C,r):new l(d,m,T,R,p,S,_,A,C)},l.fromScale=function(t,r){return e(r)?(r[0]=t.x,r[1]=0,r[2]=0,r[3]=0,r[4]=t.y,r[5]=0,r[6]=0,r[7]=0,r[8]=t.z,r):new l(t.x,0,0,0,t.y,0,0,0,t.z)},l.fromUniformScale=function(t,r){return e(r)?(r[0]=t,r[1]=0,r[2]=0,r[3]=0,r[4]=t,r[5]=0,r[6]=0,r[7]=0,r[8]=t,r):new l(t,0,0,0,t,0,0,0,t)},l.fromCrossProduct=function(t,r){return e(r)?(r[0]=0,r[1]=t.z,r[2]=-t.y,r[3]=-t.z,r[4]=0,r[5]=t.x,r[6]=t.y,r[7]=-t.x,r[8]=0,r):new l(0,-t.z,t.y,t.z,0,-t.x,-t.y,t.x,0)},l.fromRotationX=function(t,r){var n=Math.cos(t),o=Math.sin(t);return e(r)?(r[0]=1,r[1]=0,r[2]=0,r[3]=0,r[4]=n,r[5]=o,r[6]=0,r[7]=-o,r[8]=n,r):new l(1,0,0,0,n,-o,0,o,n)},l.fromRotationY=function(t,r){var n=Math.cos(t),o=Math.sin(t);return e(r)?(r[0]=n,r[1]=0,r[2]=-o,r[3]=0,r[4]=1,r[5]=0,r[6]=o,r[7]=0,r[8]=n,r):new l(n,0,o,0,1,0,-o,0,n)},l.fromRotationZ=function(t,r){var n=Math.cos(t),o=Math.sin(t);return e(r)?(r[0]=n,r[1]=o,r[2]=0,r[3]=-o,r[4]=n,r[5]=0,r[6]=0,r[7]=0,r[8]=1,r):new l(n,-o,0,o,n,0,0,0,1)},l.toArray=function(t,r){return e(r)?(r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r[8]=t[8],r):[t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8]]},l.getElementIndex=function(t,r){return 3*t+r},l.getColumn=function(t,r,e){var n=3*r,o=t[n],i=t[n+1],a=t[n+2];return e.x=o,e.y=i,e.z=a,e},l.setColumn=function(t,r,e,n){n=l.clone(t,n);var o=3*r;return n[o]=e.x,n[o+1]=e.y,n[o+2]=e.z,n},l.getRow=function(t,r,e){var n=t[r],o=t[r+3],i=t[r+6];return e.x=n,e.y=o,e.z=i,e},l.setRow=function(t,r,e,n){return n=l.clone(t,n),n[r]=e.x,n[r+3]=e.y,n[r+6]=e.z,n};var c=new t;l.getScale=function(r,e){return e.x=t.magnitude(t.fromElements(r[0],r[1],r[2],c)),e.y=t.magnitude(t.fromElements(r[3],r[4],r[5],c)),e.z=t.magnitude(t.fromElements(r[6],r[7],r[8],c)),e};var E=new t;l.getMaximumScale=function(r){return l.getScale(r,E),t.maximumComponent(E)},l.multiply=function(t,r,e){var n=t[0]*r[0]+t[3]*r[1]+t[6]*r[2],o=t[1]*r[0]+t[4]*r[1]+t[7]*r[2],i=t[2]*r[0]+t[5]*r[1]+t[8]*r[2],a=t[0]*r[3]+t[3]*r[4]+t[6]*r[5],s=t[1]*r[3]+t[4]*r[4]+t[7]*r[5],u=t[2]*r[3]+t[5]*r[4]+t[8]*r[5],l=t[0]*r[6]+t[3]*r[7]+t[6]*r[8],c=t[1]*r[6]+t[4]*r[7]+t[7]*r[8],E=t[2]*r[6]+t[5]*r[7]+t[8]*r[8];return e[0]=n,e[1]=o,e[2]=i,e[3]=a,e[4]=s,e[5]=u,e[6]=l,e[7]=c,e[8]=E,e},l.add=function(t,r,e){return e[0]=t[0]+r[0],e[1]=t[1]+r[1],e[2]=t[2]+r[2],e[3]=t[3]+r[3],e[4]=t[4]+r[4],e[5]=t[5]+r[5],e[6]=t[6]+r[6],e[7]=t[7]+r[7],e[8]=t[8]+r[8],e},l.subtract=function(t,r,e){return e[0]=t[0]-r[0],e[1]=t[1]-r[1],e[2]=t[2]-r[2],e[3]=t[3]-r[3],e[4]=t[4]-r[4],e[5]=t[5]-r[5],e[6]=t[6]-r[6],e[7]=t[7]-r[7],e[8]=t[8]-r[8],e},l.multiplyByVector=function(t,r,e){var n=r.x,o=r.y,i=r.z,a=t[0]*n+t[3]*o+t[6]*i,s=t[1]*n+t[4]*o+t[7]*i,u=t[2]*n+t[5]*o+t[8]*i;return e.x=a,e.y=s,e.z=u,e},l.multiplyByScalar=function(t,r,e){return e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e[3]=t[3]*r,e[4]=t[4]*r,e[5]=t[5]*r,e[6]=t[6]*r,e[7]=t[7]*r,e[8]=t[8]*r,e},l.multiplyByScale=function(t,r,e){return e[0]=t[0]*r.x,e[1]=t[1]*r.x,e[2]=t[2]*r.x,e[3]=t[3]*r.y,e[4]=t[4]*r.y,e[5]=t[5]*r.y,e[6]=t[6]*r.z,e[7]=t[7]*r.z,e[8]=t[8]*r.z,e},l.negate=function(t,r){return r[0]=-t[0],r[1]=-t[1],r[2]=-t[2],r[3]=-t[3],r[4]=-t[4],r[5]=-t[5],r[6]=-t[6],r[7]=-t[7],r[8]=-t[8],r},l.transpose=function(t,r){var e=t[0],n=t[3],o=t[6],i=t[1],a=t[4],s=t[7],u=t[2],l=t[5],c=t[8];return r[0]=e,r[1]=n,r[2]=o,r[3]=i,r[4]=a,r[5]=s,r[6]=u,r[7]=l,r[8]=c,r};var f=[1,0,0],h=[2,2,1],d=new l,m=new l;return l.computeEigenDecomposition=function(t,r){var n=i.EPSILON20,o=10,c=0,E=0;e(r)||(r={});for(var f=r.unitary=l.clone(l.IDENTITY,r.unitary),h=r.diagonal=l.clone(t,r.diagonal),T=n*a(h);o>E&&s(h)>T;)u(h,d),l.transpose(d,m),l.multiply(h,d,h),l.multiply(m,h,h),l.multiply(f,d,f),++c>2&&(++E,c=0);return r},l.abs=function(t,r){return r[0]=Math.abs(t[0]),r[1]=Math.abs(t[1]),r[2]=Math.abs(t[2]),r[3]=Math.abs(t[3]),r[4]=Math.abs(t[4]),r[5]=Math.abs(t[5]),r[6]=Math.abs(t[6]),r[7]=Math.abs(t[7]),r[8]=Math.abs(t[8]),r},l.determinant=function(t){var r=t[0],e=t[3],n=t[6],o=t[1],i=t[4],a=t[7],s=t[2],u=t[5],l=t[8];return r*(i*l-u*a)+o*(u*n-e*l)+s*(e*a-i*n)},l.inverse=function(t,r){var e=t[0],o=t[1],a=t[2],s=t[3],u=t[4],c=t[5],E=t[6],f=t[7],h=t[8],d=l.determinant(t);if(Math.abs(d)<=i.EPSILON15)throw new n("matrix is not invertible");r[0]=u*h-f*c,r[1]=f*a-o*h,r[2]=o*c-u*a,r[3]=E*c-s*h,r[4]=e*h-E*a,r[5]=s*a-e*c,r[6]=s*f-E*u,r[7]=E*o-e*f,r[8]=e*u-s*o;var m=1/d;return l.multiplyByScalar(r,m,r)},l.equals=function(t,r){return t===r||e(t)&&e(r)&&t[0]===r[0]&&t[1]===r[1]&&t[2]===r[2]&&t[3]===r[3]&&t[4]===r[4]&&t[5]===r[5]&&t[6]===r[6]&&t[7]===r[7]&&t[8]===r[8]},l.equalsEpsilon=function(t,r,n){return t===r||e(t)&&e(r)&&Math.abs(t[0]-r[0])<=n&&Math.abs(t[1]-r[1])<=n&&Math.abs(t[2]-r[2])<=n&&Math.abs(t[3]-r[3])<=n&&Math.abs(t[4]-r[4])<=n&&Math.abs(t[5]-r[5])<=n&&Math.abs(t[6]-r[6])<=n&&Math.abs(t[7]-r[7])<=n&&Math.abs(t[8]-r[8])<=n},l.IDENTITY=o(new l(1,0,0,0,1,0,0,0,1)),l.ZERO=o(new l(0,0,0,0,0,0,0,0,0)),l.COLUMN0ROW0=0,l.COLUMN0ROW1=1,l.COLUMN0ROW2=2,l.COLUMN1ROW0=3,l.COLUMN1ROW1=4,l.COLUMN1ROW2=5,l.COLUMN2ROW0=6,l.COLUMN2ROW1=7,l.COLUMN2ROW2=8,l.prototype.clone=function(t){return l.clone(this,t)},l.prototype.equals=function(t){return l.equals(this,t)},l.equalsArray=function(t,r,e){return t[0]===r[e]&&t[1]===r[e+1]&&t[2]===r[e+2]&&t[3]===r[e+3]&&t[4]===r[e+4]&&t[5]===r[e+5]&&t[6]===r[e+6]&&t[7]===r[e+7]&&t[8]===r[e+8]},l.prototype.equalsEpsilon=function(t,r){return l.equalsEpsilon(this,t,r)},l.prototype.toString=function(){return"("+this[0]+", "+this[3]+", "+this[6]+")\n"+"("+this[1]+", "+this[4]+", "+this[7]+")\n"+"("+this[2]+", "+this[5]+", "+this[8]+")"},l}),define("Core/RuntimeError",["./defined"],function(t){"use strict";var r=function(t){this.name="RuntimeError",this.message=t;var r;try{throw new Error}catch(e){r=e.stack}this.stack=r};return r.prototype.toString=function(){var r=this.name+": "+this.message;return t(this.stack)&&(r+="\n"+this.stack.toString()),r},r}),define("Core/Matrix4",["./Cartesian3","./Cartesian4","./defaultValue","./defined","./DeveloperError","./freezeObject","./Math","./Matrix3","./RuntimeError"],function(t,r,e,n,o,i,a,s,u){"use strict";var l=function(t,r,n,o,i,a,s,u,l,c,E,f,h,d,m,T){this[0]=e(t,0),this[1]=e(i,0),this[2]=e(l,0),this[3]=e(h,0),this[4]=e(r,0),this[5]=e(a,0),this[6]=e(c,0),this[7]=e(d,0),this[8]=e(n,0),this[9]=e(s,0),this[10]=e(E,0),this[11]=e(m,0),this[12]=e(o,0),this[13]=e(u,0),this[14]=e(f,0),this[15]=e(T,0)};l.packedLength=16,l.pack=function(t,r,n){n=e(n,0),r[n++]=t[0],r[n++]=t[1],r[n++]=t[2],r[n++]=t[3],r[n++]=t[4],r[n++]=t[5],r[n++]=t[6],r[n++]=t[7],r[n++]=t[8],r[n++]=t[9],r[n++]=t[10],r[n++]=t[11],r[n++]=t[12],r[n++]=t[13],r[n++]=t[14],r[n]=t[15]},l.unpack=function(t,r,o){return r=e(r,0),n(o)||(o=new l),o[0]=t[r++],o[1]=t[r++],o[2]=t[r++],o[3]=t[r++],o[4]=t[r++],o[5]=t[r++],o[6]=t[r++],o[7]=t[r++],o[8]=t[r++],o[9]=t[r++],o[10]=t[r++],o[11]=t[r++],o[12]=t[r++],o[13]=t[r++],o[14]=t[r++],o[15]=t[r],o},l.clone=function(t,r){return n(t)?n(r)?(r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r[8]=t[8],r[9]=t[9],r[10]=t[10],r[11]=t[11],r[12]=t[12],r[13]=t[13],r[14]=t[14],r[15]=t[15],r):new l(t[0],t[4],t[8],t[12],t[1],t[5],t[9],t[13],t[2],t[6],t[10],t[14],t[3],t[7],t[11],t[15]):void 0},l.fromArray=l.unpack,l.fromColumnMajorArray=function(t,r){return l.clone(t,r)},l.fromRowMajorArray=function(t,r){return n(r)?(r[0]=t[0],r[1]=t[4],r[2]=t[8],r[3]=t[12],r[4]=t[1],r[5]=t[5],r[6]=t[9],r[7]=t[13],r[8]=t[2],r[9]=t[6],r[10]=t[10],r[11]=t[14],r[12]=t[3],r[13]=t[7],r[14]=t[11],r[15]=t[15],r):new l(t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15])},l.fromRotationTranslation=function(r,o,i){return o=e(o,t.ZERO),n(i)?(i[0]=r[0],i[1]=r[1],i[2]=r[2],i[3]=0,i[4]=r[3],i[5]=r[4],i[6]=r[5],i[7]=0,i[8]=r[6],i[9]=r[7],i[10]=r[8],i[11]=0,i[12]=o.x,i[13]=o.y,i[14]=o.z,i[15]=1,i):new l(r[0],r[3],r[6],o.x,r[1],r[4],r[7],o.y,r[2],r[5],r[8],o.z,0,0,0,1)},l.fromTranslationQuaternionRotationScale=function(t,r,e,o){n(o)||(o=new l);var i=e.x,a=e.y,s=e.z,u=r.x*r.x,c=r.x*r.y,E=r.x*r.z,f=r.x*r.w,h=r.y*r.y,d=r.y*r.z,m=r.y*r.w,T=r.z*r.z,R=r.z*r.w,p=r.w*r.w,S=u-h-T+p,_=2*(c-R),A=2*(E+m),C=2*(c+R),g=-u+h-T+p,y=2*(d-f),N=2*(E-m),v=2*(d+f),I=-u-h+T+p;return o[0]=S*i,o[1]=C*i,o[2]=N*i,o[3]=0,o[4]=_*a,o[5]=g*a,o[6]=v*a,o[7]=0,o[8]=A*s,o[9]=y*s,o[10]=I*s,o[11]=0,o[12]=t.x,o[13]=t.y,o[14]=t.z,o[15]=1,o},l.fromTranslation=function(t,r){return l.fromRotationTranslation(s.IDENTITY,t,r)},l.fromScale=function(t,r){return n(r)?(r[0]=t.x,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=t.y,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=t.z,r[11]=0,r[12]=0,r[13]=0,r[14]=0,r[15]=1,r):new l(t.x,0,0,0,0,t.y,0,0,0,0,t.z,0,0,0,0,1)},l.fromUniformScale=function(t,r){return n(r)?(r[0]=t,r[1]=0,r[2]=0,r[3]=0,r[4]=0,r[5]=t,r[6]=0,r[7]=0,r[8]=0,r[9]=0,r[10]=t,r[11]=0,r[12]=0,r[13]=0,r[14]=0,r[15]=1,r):new l(t,0,0,0,0,t,0,0,0,0,t,0,0,0,0,1)};var c=new t,E=new t,f=new t;l.fromCamera=function(r,e){var o=r.eye,i=r.target,a=r.up;t.normalize(t.subtract(i,o,c),c),t.normalize(t.cross(c,a,E),E),t.normalize(t.cross(E,c,f),f);var s=E.x,u=E.y,h=E.z,d=c.x,m=c.y,T=c.z,R=f.x,p=f.y,S=f.z,_=o.x,A=o.y,C=o.z,g=s*-_+u*-A+h*-C,y=R*-_+p*-A+S*-C,N=d*_+m*A+T*C;return n(e)?(e[0]=s,e[1]=R,e[2]=-d,e[3]=0,e[4]=u,e[5]=p,e[6]=-m,e[7]=0,e[8]=h,e[9]=S,e[10]=-T,e[11]=0,e[12]=g,e[13]=y,e[14]=N,e[15]=1,e):new l(s,u,h,g,R,p,S,y,-d,-m,-T,N,0,0,0,1)},l.computePerspectiveFieldOfView=function(t,r,e,n,o){var i=Math.tan(.5*t),a=1/i,s=a/r,u=(n+e)/(e-n),l=2*n*e/(e-n);return o[0]=s,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=a,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=u,o[11]=-1,o[12]=0,o[13]=0,o[14]=l,o[15]=0,o},l.computeOrthographicOffCenter=function(t,r,e,n,o,i,a){var s=1/(r-t),u=1/(n-e),l=1/(i-o),c=-(r+t)*s,E=-(n+e)*u,f=-(i+o)*l;return s*=2,u*=2,l*=-2,a[0]=s,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=u,a[6]=0,a[7]=0,a[8]=0,a[9]=0,a[10]=l,a[11]=0,a[12]=c,a[13]=E,a[14]=f,a[15]=1,a
},l.computePerspectiveOffCenter=function(t,r,e,n,o,i,a){var s=2*o/(r-t),u=2*o/(n-e),l=(r+t)/(r-t),c=(n+e)/(n-e),E=-(i+o)/(i-o),f=-1,h=-2*i*o/(i-o);return a[0]=s,a[1]=0,a[2]=0,a[3]=0,a[4]=0,a[5]=u,a[6]=0,a[7]=0,a[8]=l,a[9]=c,a[10]=E,a[11]=f,a[12]=0,a[13]=0,a[14]=h,a[15]=0,a},l.computeInfinitePerspectiveOffCenter=function(t,r,e,n,o,i){var a=2*o/(r-t),s=2*o/(n-e),u=(r+t)/(r-t),l=(n+e)/(n-e),c=-1,E=-1,f=-2*o;return i[0]=a,i[1]=0,i[2]=0,i[3]=0,i[4]=0,i[5]=s,i[6]=0,i[7]=0,i[8]=u,i[9]=l,i[10]=c,i[11]=E,i[12]=0,i[13]=0,i[14]=f,i[15]=0,i},l.computeViewportTransformation=function(t,r,n,o){t=e(t,e.EMPTY_OBJECT);var i=e(t.x,0),a=e(t.y,0),s=e(t.width,0),u=e(t.height,0);r=e(r,0),n=e(n,1);var l=.5*s,c=.5*u,E=.5*(n-r),f=l,h=c,d=E,m=i+l,T=a+c,R=r+E,p=1;return o[0]=f,o[1]=0,o[2]=0,o[3]=0,o[4]=0,o[5]=h,o[6]=0,o[7]=0,o[8]=0,o[9]=0,o[10]=d,o[11]=0,o[12]=m,o[13]=T,o[14]=R,o[15]=p,o},l.toArray=function(t,r){return n(r)?(r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[3],r[4]=t[4],r[5]=t[5],r[6]=t[6],r[7]=t[7],r[8]=t[8],r[9]=t[9],r[10]=t[10],r[11]=t[11],r[12]=t[12],r[13]=t[13],r[14]=t[14],r[15]=t[15],r):[t[0],t[1],t[2],t[3],t[4],t[5],t[6],t[7],t[8],t[9],t[10],t[11],t[12],t[13],t[14],t[15]]},l.getElementIndex=function(t,r){return 4*t+r},l.getColumn=function(t,r,e){var n=4*r,o=t[n],i=t[n+1],a=t[n+2],s=t[n+3];return e.x=o,e.y=i,e.z=a,e.w=s,e},l.setColumn=function(t,r,e,n){n=l.clone(t,n);var o=4*r;return n[o]=e.x,n[o+1]=e.y,n[o+2]=e.z,n[o+3]=e.w,n},l.setTranslation=function(t,r,e){return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=r.x,e[13]=r.y,e[14]=r.z,e[15]=t[15],e},l.getRow=function(t,r,e){var n=t[r],o=t[r+4],i=t[r+8],a=t[r+12];return e.x=n,e.y=o,e.z=i,e.w=a,e},l.setRow=function(t,r,e,n){return n=l.clone(t,n),n[r]=e.x,n[r+4]=e.y,n[r+8]=e.z,n[r+12]=e.w,n};var h=new t;l.getScale=function(r,e){return e.x=t.magnitude(t.fromElements(r[0],r[1],r[2],h)),e.y=t.magnitude(t.fromElements(r[4],r[5],r[6],h)),e.z=t.magnitude(t.fromElements(r[8],r[9],r[10],h)),e};var d=new t;l.getMaximumScale=function(r){return l.getScale(r,d),t.maximumComponent(d)},l.multiply=function(t,r,e){var n=t[0],o=t[1],i=t[2],a=t[3],s=t[4],u=t[5],l=t[6],c=t[7],E=t[8],f=t[9],h=t[10],d=t[11],m=t[12],T=t[13],R=t[14],p=t[15],S=r[0],_=r[1],A=r[2],C=r[3],g=r[4],y=r[5],N=r[6],v=r[7],I=r[8],O=r[9],M=r[10],L=r[11],w=r[12],F=r[13],P=r[14],D=r[15],U=n*S+s*_+E*A+m*C,x=o*S+u*_+f*A+T*C,B=i*S+l*_+h*A+R*C,b=a*S+c*_+d*A+p*C,z=n*g+s*y+E*N+m*v,G=o*g+u*y+f*N+T*v,q=i*g+l*y+h*N+R*v,H=a*g+c*y+d*N+p*v,V=n*I+s*O+E*M+m*L,W=o*I+u*O+f*M+T*L,Y=i*I+l*O+h*M+R*L,X=a*I+c*O+d*M+p*L,k=n*w+s*F+E*P+m*D,K=o*w+u*F+f*P+T*D,Z=i*w+l*F+h*P+R*D,j=a*w+c*F+d*P+p*D;return e[0]=U,e[1]=x,e[2]=B,e[3]=b,e[4]=z,e[5]=G,e[6]=q,e[7]=H,e[8]=V,e[9]=W,e[10]=Y,e[11]=X,e[12]=k,e[13]=K,e[14]=Z,e[15]=j,e},l.add=function(t,r,e){return e[0]=t[0]+r[0],e[1]=t[1]+r[1],e[2]=t[2]+r[2],e[3]=t[3]+r[3],e[4]=t[4]+r[4],e[5]=t[5]+r[5],e[6]=t[6]+r[6],e[7]=t[7]+r[7],e[8]=t[8]+r[8],e[9]=t[9]+r[9],e[10]=t[10]+r[10],e[11]=t[11]+r[11],e[12]=t[12]+r[12],e[13]=t[13]+r[13],e[14]=t[14]+r[14],e[15]=t[15]+r[15],e},l.subtract=function(t,r,e){return e[0]=t[0]-r[0],e[1]=t[1]-r[1],e[2]=t[2]-r[2],e[3]=t[3]-r[3],e[4]=t[4]-r[4],e[5]=t[5]-r[5],e[6]=t[6]-r[6],e[7]=t[7]-r[7],e[8]=t[8]-r[8],e[9]=t[9]-r[9],e[10]=t[10]-r[10],e[11]=t[11]-r[11],e[12]=t[12]-r[12],e[13]=t[13]-r[13],e[14]=t[14]-r[14],e[15]=t[15]-r[15],e},l.multiplyTransformation=function(t,r,e){var n=t[0],o=t[1],i=t[2],a=t[4],s=t[5],u=t[6],l=t[8],c=t[9],E=t[10],f=t[12],h=t[13],d=t[14],m=r[0],T=r[1],R=r[2],p=r[4],S=r[5],_=r[6],A=r[8],C=r[9],g=r[10],y=r[12],N=r[13],v=r[14],I=n*m+a*T+l*R,O=o*m+s*T+c*R,M=i*m+u*T+E*R,L=n*p+a*S+l*_,w=o*p+s*S+c*_,F=i*p+u*S+E*_,P=n*A+a*C+l*g,D=o*A+s*C+c*g,U=i*A+u*C+E*g,x=n*y+a*N+l*v+f,B=o*y+s*N+c*v+h,b=i*y+u*N+E*v+d;return e[0]=I,e[1]=O,e[2]=M,e[3]=0,e[4]=L,e[5]=w,e[6]=F,e[7]=0,e[8]=P,e[9]=D,e[10]=U,e[11]=0,e[12]=x,e[13]=B,e[14]=b,e[15]=1,e},l.multiplyByMatrix3=function(t,r,e){var n=t[0],o=t[1],i=t[2],a=t[4],s=t[5],u=t[6],l=t[8],c=t[9],E=t[10],f=r[0],h=r[1],d=r[2],m=r[3],T=r[4],R=r[5],p=r[6],S=r[7],_=r[8],A=n*f+a*h+l*d,C=o*f+s*h+c*d,g=i*f+u*h+E*d,y=n*m+a*T+l*R,N=o*m+s*T+c*R,v=i*m+u*T+E*R,I=n*p+a*S+l*_,O=o*p+s*S+c*_,M=i*p+u*S+E*_;return e[0]=A,e[1]=C,e[2]=g,e[3]=0,e[4]=y,e[5]=N,e[6]=v,e[7]=0,e[8]=I,e[9]=O,e[10]=M,e[11]=0,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=t[15],e},l.multiplyByTranslation=function(t,r,e){var n=r.x,o=r.y,i=r.z,a=n*t[0]+o*t[4]+i*t[8]+t[12],s=n*t[1]+o*t[5]+i*t[9]+t[13],u=n*t[2]+o*t[6]+i*t[10]+t[14];return e[0]=t[0],e[1]=t[1],e[2]=t[2],e[3]=t[3],e[4]=t[4],e[5]=t[5],e[6]=t[6],e[7]=t[7],e[8]=t[8],e[9]=t[9],e[10]=t[10],e[11]=t[11],e[12]=a,e[13]=s,e[14]=u,e[15]=t[15],e};var m=new t;l.multiplyByUniformScale=function(t,r,e){return m.x=r,m.y=r,m.z=r,l.multiplyByScale(t,m,e)},l.multiplyByScale=function(t,r,e){var n=r.x,o=r.y,i=r.z;return 1===n&&1===o&&1===i?l.clone(t,e):(e[0]=n*t[0],e[1]=n*t[1],e[2]=n*t[2],e[3]=0,e[4]=o*t[4],e[5]=o*t[5],e[6]=o*t[6],e[7]=0,e[8]=i*t[8],e[9]=i*t[9],e[10]=i*t[10],e[11]=0,e[12]=t[12],e[13]=t[13],e[14]=t[14],e[15]=1,e)},l.multiplyByVector=function(t,r,e){var n=r.x,o=r.y,i=r.z,a=r.w,s=t[0]*n+t[4]*o+t[8]*i+t[12]*a,u=t[1]*n+t[5]*o+t[9]*i+t[13]*a,l=t[2]*n+t[6]*o+t[10]*i+t[14]*a,c=t[3]*n+t[7]*o+t[11]*i+t[15]*a;return e.x=s,e.y=u,e.z=l,e.w=c,e},l.multiplyByPointAsVector=function(t,r,e){var n=r.x,o=r.y,i=r.z,a=t[0]*n+t[4]*o+t[8]*i,s=t[1]*n+t[5]*o+t[9]*i,u=t[2]*n+t[6]*o+t[10]*i;return e.x=a,e.y=s,e.z=u,e},l.multiplyByPoint=function(t,r,e){var n=r.x,o=r.y,i=r.z,a=t[0]*n+t[4]*o+t[8]*i+t[12],s=t[1]*n+t[5]*o+t[9]*i+t[13],u=t[2]*n+t[6]*o+t[10]*i+t[14];return e.x=a,e.y=s,e.z=u,e},l.multiplyByScalar=function(t,r,e){return e[0]=t[0]*r,e[1]=t[1]*r,e[2]=t[2]*r,e[3]=t[3]*r,e[4]=t[4]*r,e[5]=t[5]*r,e[6]=t[6]*r,e[7]=t[7]*r,e[8]=t[8]*r,e[9]=t[9]*r,e[10]=t[10]*r,e[11]=t[11]*r,e[12]=t[12]*r,e[13]=t[13]*r,e[14]=t[14]*r,e[15]=t[15]*r,e},l.negate=function(t,r){return r[0]=-t[0],r[1]=-t[1],r[2]=-t[2],r[3]=-t[3],r[4]=-t[4],r[5]=-t[5],r[6]=-t[6],r[7]=-t[7],r[8]=-t[8],r[9]=-t[9],r[10]=-t[10],r[11]=-t[11],r[12]=-t[12],r[13]=-t[13],r[14]=-t[14],r[15]=-t[15],r},l.transpose=function(t,r){var e=t[1],n=t[2],o=t[3],i=t[6],a=t[7],s=t[11];return r[0]=t[0],r[1]=t[4],r[2]=t[8],r[3]=t[12],r[4]=e,r[5]=t[5],r[6]=t[9],r[7]=t[13],r[8]=n,r[9]=i,r[10]=t[10],r[11]=t[14],r[12]=o,r[13]=a,r[14]=s,r[15]=t[15],r},l.abs=function(t,r){return r[0]=Math.abs(t[0]),r[1]=Math.abs(t[1]),r[2]=Math.abs(t[2]),r[3]=Math.abs(t[3]),r[4]=Math.abs(t[4]),r[5]=Math.abs(t[5]),r[6]=Math.abs(t[6]),r[7]=Math.abs(t[7]),r[8]=Math.abs(t[8]),r[9]=Math.abs(t[9]),r[10]=Math.abs(t[10]),r[11]=Math.abs(t[11]),r[12]=Math.abs(t[12]),r[13]=Math.abs(t[13]),r[14]=Math.abs(t[14]),r[15]=Math.abs(t[15]),r},l.equals=function(t,r){return t===r||n(t)&&n(r)&&t[12]===r[12]&&t[13]===r[13]&&t[14]===r[14]&&t[0]===r[0]&&t[1]===r[1]&&t[2]===r[2]&&t[4]===r[4]&&t[5]===r[5]&&t[6]===r[6]&&t[8]===r[8]&&t[9]===r[9]&&t[10]===r[10]&&t[3]===r[3]&&t[7]===r[7]&&t[11]===r[11]&&t[15]===r[15]},l.equalsEpsilon=function(t,r,e){return t===r||n(t)&&n(r)&&Math.abs(t[0]-r[0])<=e&&Math.abs(t[1]-r[1])<=e&&Math.abs(t[2]-r[2])<=e&&Math.abs(t[3]-r[3])<=e&&Math.abs(t[4]-r[4])<=e&&Math.abs(t[5]-r[5])<=e&&Math.abs(t[6]-r[6])<=e&&Math.abs(t[7]-r[7])<=e&&Math.abs(t[8]-r[8])<=e&&Math.abs(t[9]-r[9])<=e&&Math.abs(t[10]-r[10])<=e&&Math.abs(t[11]-r[11])<=e&&Math.abs(t[12]-r[12])<=e&&Math.abs(t[13]-r[13])<=e&&Math.abs(t[14]-r[14])<=e&&Math.abs(t[15]-r[15])<=e},l.getTranslation=function(t,r){return r.x=t[12],r.y=t[13],r.z=t[14],r},l.getRotation=function(t,r){return r[0]=t[0],r[1]=t[1],r[2]=t[2],r[3]=t[4],r[4]=t[5],r[5]=t[6],r[6]=t[8],r[7]=t[9],r[8]=t[10],r};var T=new s,R=new s,p=new r,S=new r(0,0,0,1);return l.inverse=function(t,e){if(s.equalsEpsilon(l.getRotation(t,T),R,a.EPSILON7)&&r.equals(l.getRow(t,3,p),S))return e[0]=0,e[1]=0,e[2]=0,e[3]=0,e[4]=0,e[5]=0,e[6]=0,e[7]=0,e[8]=0,e[9]=0,e[10]=0,e[11]=0,e[12]=-t[12],e[13]=-t[13],e[14]=-t[14],e[15]=1,e;var n=t[0],o=t[4],i=t[8],c=t[12],E=t[1],f=t[5],h=t[9],d=t[13],m=t[2],_=t[6],A=t[10],C=t[14],g=t[3],y=t[7],N=t[11],v=t[15],I=A*v,O=C*N,M=_*v,L=C*y,w=_*N,F=A*y,P=m*v,D=C*g,U=m*N,x=A*g,B=m*y,b=_*g,z=I*f+L*h+w*d-(O*f+M*h+F*d),G=O*E+P*h+x*d-(I*E+D*h+U*d),q=M*E+D*f+B*d-(L*E+P*f+b*d),H=F*E+U*f+b*h-(w*E+x*f+B*h),V=O*o+M*i+F*c-(I*o+L*i+w*c),W=I*n+D*i+U*c-(O*n+P*i+x*c),Y=L*n+P*o+b*c-(M*n+D*o+B*c),X=w*n+x*o+B*i-(F*n+U*o+b*i);I=i*d,O=c*h,M=o*d,L=c*f,w=o*h,F=i*f,P=n*d,D=c*E,U=n*h,x=i*E,B=n*f,b=o*E;var k=I*y+L*N+w*v-(O*y+M*N+F*v),K=O*g+P*N+x*v-(I*g+D*N+U*v),Z=M*g+D*y+B*v-(L*g+P*y+b*v),j=F*g+U*y+b*N-(w*g+x*y+B*N),Q=M*A+F*C+O*_-(w*C+I*_+L*A),J=U*C+I*m+D*A-(P*A+x*C+O*m),$=P*_+b*C+L*m-(B*C+M*m+D*_),tr=B*A+w*m+x*_-(U*_+b*A+F*m),rr=n*z+o*G+i*q+c*H;if(Math.abs(rr)<a.EPSILON20)throw new u("matrix is not invertible because its determinate is zero.");return rr=1/rr,e[0]=z*rr,e[1]=G*rr,e[2]=q*rr,e[3]=H*rr,e[4]=V*rr,e[5]=W*rr,e[6]=Y*rr,e[7]=X*rr,e[8]=k*rr,e[9]=K*rr,e[10]=Z*rr,e[11]=j*rr,e[12]=Q*rr,e[13]=J*rr,e[14]=$*rr,e[15]=tr*rr,e},l.inverseTransformation=function(t,r){var e=t[0],n=t[1],o=t[2],i=t[4],a=t[5],s=t[6],u=t[8],l=t[9],c=t[10],E=t[12],f=t[13],h=t[14],d=-e*E-n*f-o*h,m=-i*E-a*f-s*h,T=-u*E-l*f-c*h;return r[0]=e,r[1]=i,r[2]=u,r[3]=0,r[4]=n,r[5]=a,r[6]=l,r[7]=0,r[8]=o,r[9]=s,r[10]=c,r[11]=0,r[12]=d,r[13]=m,r[14]=T,r[15]=1,r},l.IDENTITY=i(new l(1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1)),l.ZERO=i(new l(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)),l.COLUMN0ROW0=0,l.COLUMN0ROW1=1,l.COLUMN0ROW2=2,l.COLUMN0ROW3=3,l.COLUMN1ROW0=4,l.COLUMN1ROW1=5,l.COLUMN1ROW2=6,l.COLUMN1ROW3=7,l.COLUMN2ROW0=8,l.COLUMN2ROW1=9,l.COLUMN2ROW2=10,l.COLUMN2ROW3=11,l.COLUMN3ROW0=12,l.COLUMN3ROW1=13,l.COLUMN3ROW2=14,l.COLUMN3ROW3=15,l.prototype.clone=function(t){return l.clone(this,t)},l.prototype.equals=function(t){return l.equals(this,t)},l.equalsArray=function(t,r,e){return t[0]===r[e]&&t[1]===r[e+1]&&t[2]===r[e+2]&&t[3]===r[e+3]&&t[4]===r[e+4]&&t[5]===r[e+5]&&t[6]===r[e+6]&&t[7]===r[e+7]&&t[8]===r[e+8]&&t[9]===r[e+9]&&t[10]===r[e+10]&&t[11]===r[e+11]&&t[12]===r[e+12]&&t[13]===r[e+13]&&t[14]===r[e+14]&&t[15]===r[e+15]},l.prototype.equalsEpsilon=function(t,r){return l.equalsEpsilon(this,t,r)},l.prototype.toString=function(){return"("+this[0]+", "+this[4]+", "+this[8]+", "+this[12]+")\n"+"("+this[1]+", "+this[5]+", "+this[9]+", "+this[13]+")\n"+"("+this[2]+", "+this[6]+", "+this[10]+", "+this[14]+")\n"+"("+this[3]+", "+this[7]+", "+this[11]+", "+this[15]+")"},l}),define("Core/Plane",["./Cartesian3","./defined","./DeveloperError","./freezeObject"],function(t,r,e,n){"use strict";var o=function(r,e){this.normal=t.clone(r),this.distance=e};o.fromPointNormal=function(e,n,i){var a=-t.dot(n,e);return r(i)?(t.clone(n,i.normal),i.distance=a,i):new o(n,a)};var i=new t;return o.fromCartesian4=function(e,n){var a=t.fromCartesian4(e,i),s=e.w;return r(n)?(t.clone(a,n.normal),n.distance=s,n):new o(a,s)},o.getPointDistance=function(r,e){return t.dot(r.normal,e)+r.distance},o.ORIGIN_XY_PLANE=n(new o(t.UNIT_Z,0)),o.ORIGIN_YZ_PLANE=n(new o(t.UNIT_X,0)),o.ORIGIN_ZX_PLANE=n(new o(t.UNIT_Y,0)),o}),define("Core/Rectangle",["./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./freezeObject","./Math"],function(t,r,e,n,o,i,a,s){"use strict";var u=function(t,e,n,o){this.west=r(t,0),this.south=r(e,0),this.east=r(n,0),this.north=r(o,0)};n(u.prototype,{width:{get:function(){return u.computeWidth(this)}},height:{get:function(){return u.computeHeight(this)}}}),u.packedLength=4,u.pack=function(t,e,n){n=r(n,0),e[n++]=t.west,e[n++]=t.south,e[n++]=t.east,e[n]=t.north},u.unpack=function(t,n,o){return n=r(n,0),e(o)||(o=new u),o.west=t[n++],o.south=t[n++],o.east=t[n++],o.north=t[n],o},u.computeWidth=function(t){var r=t.east,e=t.west;return e>r&&(r+=s.TWO_PI),r-e},u.computeHeight=function(t){return t.north-t.south},u.fromDegrees=function(t,n,o,i,a){return t=s.toRadians(r(t,0)),n=s.toRadians(r(n,0)),o=s.toRadians(r(o,0)),i=s.toRadians(r(i,0)),e(a)?(a.west=t,a.south=n,a.east=o,a.north=i,a):new u(t,n,o,i)},u.fromCartographicArray=function(t,r){for(var n=Number.MAX_VALUE,o=-Number.MAX_VALUE,i=Number.MAX_VALUE,a=-Number.MAX_VALUE,s=0,l=t.length;l>s;s++){var c=t[s];n=Math.min(n,c.longitude),o=Math.max(o,c.longitude),i=Math.min(i,c.latitude),a=Math.max(a,c.latitude)}return e(r)?(r.west=n,r.south=i,r.east=o,r.north=a,r):new u(n,i,o,a)},u.packedLength=4,u.pack=function(t,e,n){n=r(n,0),e[n++]=t.west,e[n++]=t.south,e[n++]=t.east,e[n]=t.north},u.unpack=function(t,n,o){return n=r(n,0),e(o)||(o=new u),o.west=t[n++],o.south=t[n++],o.east=t[n++],o.north=t[n],o},u.clone=function(t,r){return e(t)?e(r)?(r.west=t.west,r.south=t.south,r.east=t.east,r.north=t.north,r):new u(t.west,t.south,t.east,t.north):void 0},u.prototype.clone=function(t){return u.clone(this,t)},u.prototype.equals=function(t){return u.equals(this,t)},u.equals=function(t,r){return t===r||e(t)&&e(r)&&t.west===r.west&&t.south===r.south&&t.east===r.east&&t.north===r.north},u.prototype.equalsEpsilon=function(t,r){return e(t)&&Math.abs(this.west-t.west)<=r&&Math.abs(this.south-t.south)<=r&&Math.abs(this.east-t.east)<=r&&Math.abs(this.north-t.north)<=r},u.validate=function(){},u.southwest=function(r,n){return e(n)?(n.longitude=r.west,n.latitude=r.south,n.height=0,n):new t(r.west,r.south)},u.northwest=function(r,n){return e(n)?(n.longitude=r.west,n.latitude=r.north,n.height=0,n):new t(r.west,r.north)},u.northeast=function(r,n){return e(n)?(n.longitude=r.east,n.latitude=r.north,n.height=0,n):new t(r.east,r.north)},u.southeast=function(r,n){return e(n)?(n.longitude=r.east,n.latitude=r.south,n.height=0,n):new t(r.east,r.south)},u.center=function(r,n){var o=r.east,i=r.west;i>o&&(o+=s.TWO_PI);var a=s.negativePiToPi(.5*(i+o)),u=.5*(r.south+r.north);return e(n)?(n.longitude=a,n.latitude=u,n.height=0,n):new t(a,u)},u.intersection=function(t,r,n){var o=t.east,i=t.west,a=r.east,l=r.west;i>o&&a>0?o+=s.TWO_PI:l>a&&o>0&&(a+=s.TWO_PI),i>o&&0>l?l+=s.TWO_PI:l>a&&0>i&&(i+=s.TWO_PI);var c=s.negativePiToPi(Math.max(i,l)),E=s.negativePiToPi(Math.min(o,a));if((t.west<t.east||r.west<r.east)&&c>=E)return void 0;var f=Math.max(t.south,r.south),h=Math.min(t.north,r.north);return f>=h?void 0:e(n)?(n.west=c,n.south=f,n.east=E,n.north=h,n):new u(c,f,E,h)},u.contains=function(t,r){var e=r.longitude,n=r.latitude,o=t.west,i=t.east;return o>i&&(i+=s.TWO_PI,0>e&&(e+=s.TWO_PI)),(e>o||s.equalsEpsilon(e,o,s.EPSILON14))&&(i>e||s.equalsEpsilon(e,i,s.EPSILON14))&&n>=t.south&&n<=t.north};var l=new t;return u.subsample=function(t,n,o,a){n=r(n,i.WGS84),o=r(o,0),e(a)||(a=[]);var c=0,E=t.north,f=t.south,h=t.east,d=t.west,m=l;m.height=o,m.longitude=d,m.latitude=E,a[c]=n.cartographicToCartesian(m,a[c]),c++,m.longitude=h,a[c]=n.cartographicToCartesian(m,a[c]),c++,m.latitude=f,a[c]=n.cartographicToCartesian(m,a[c]),c++,m.longitude=d,a[c]=n.cartographicToCartesian(m,a[c]),c++,m.latitude=0>E?E:f>0?f:0;for(var T=1;8>T;++T)m.longitude=-Math.PI+T*s.PI_OVER_TWO,u.contains(t,m)&&(a[c]=n.cartographicToCartesian(m,a[c]),c++);return 0===m.latitude&&(m.longitude=d,a[c]=n.cartographicToCartesian(m,a[c]),c++,m.longitude=h,a[c]=n.cartographicToCartesian(m,a[c]),c++),a.length=c,a},u.MAX_VALUE=a(new u(-Math.PI,-s.PI_OVER_TWO,Math.PI,s.PI_OVER_TWO)),u}),define("Core/BoundingSphere",["./Cartesian3","./Cartographic","./defaultValue","./defined","./deprecationWarning","./DeveloperError","./Ellipsoid","./GeographicProjection","./Intersect","./Interval","./Matrix4","./Plane","./Rectangle"],function(t,r,e,n,o,i,a,s,u,l,c,E,f){"use strict";var h=function(r,n){this.center=t.clone(e(r,t.ZERO)),this.radius=e(n,0)},d=new t,m=new t,T=new t,R=new t,p=new t,S=new t,_=new t,A=new t,C=new t,g=new t,y=new t,N=new t;h.fromPoints=function(r,e){if(n(e)||(e=new h),!n(r)||0===r.length)return e.center=t.clone(t.ZERO,e.center),e.radius=0,e;for(var o=t.clone(r[0],_),i=t.clone(o,d),a=t.clone(o,m),s=t.clone(o,T),u=t.clone(o,R),l=t.clone(o,p),c=t.clone(o,S),E=r.length,f=1;E>f;f++){t.clone(r[f],o);var v=o.x,I=o.y,O=o.z;v<i.x&&t.clone(o,i),v>u.x&&t.clone(o,u),I<a.y&&t.clone(o,a),I>l.y&&t.clone(o,l),O<s.z&&t.clone(o,s),O>c.z&&t.clone(o,c)}var M=t.magnitudeSquared(t.subtract(u,i,A)),L=t.magnitudeSquared(t.subtract(l,a,A)),w=t.magnitudeSquared(t.subtract(c,s,A)),F=i,P=u,D=M;L>D&&(D=L,F=a,P=l),w>D&&(D=w,F=s,P=c);var U=C;U.x=.5*(F.x+P.x),U.y=.5*(F.y+P.y),U.z=.5*(F.z+P.z);var x=t.magnitudeSquared(t.subtract(P,U,A)),B=Math.sqrt(x),b=g;b.x=i.x,b.y=a.y,b.z=s.z;var z=y;z.x=u.x,z.y=l.y,z.z=c.z;var G=t.multiplyByScalar(t.add(b,z,A),.5,N),q=0;for(f=0;E>f;f++){t.clone(r[f],o);var H=t.magnitude(t.subtract(o,G,A));H>q&&(q=H);var V=t.magnitudeSquared(t.subtract(o,U,A));if(V>x){var W=Math.sqrt(V);B=.5*(B+W),x=B*B;var Y=W-B;U.x=(B*U.x+Y*o.x)/W,U.y=(B*U.y+Y*o.y)/W,U.z=(B*U.z+Y*o.z)/W}}return q>B?(t.clone(U,e.center),e.radius=B):(t.clone(G,e.center),e.radius=q),e};var v=new s,I=new t,O=new t,M=new r,L=new r;h.fromRectangle2D=function(t,r,e){return h.fromRectangleWithHeights2D(t,r,0,0,e)},h.fromRectangleWithHeights2D=function(r,o,i,a,s){if(n(s)||(s=new h),!n(r))return s.center=t.clone(t.ZERO,s.center),s.radius=0,s;o=e(o,v),f.southwest(r,M),M.height=i,f.northeast(r,L),L.height=a;var u=o.project(M,I),l=o.project(L,O),c=l.x-u.x,E=l.y-u.y,d=l.z-u.z;s.radius=.5*Math.sqrt(c*c+E*E+d*d);var m=s.center;return m.x=u.x+.5*c,m.y=u.y+.5*E,m.z=u.z+.5*d,s};var w=[];h.fromRectangle3D=function(t,r,o,i){r=e(r,a.WGS84),o=e(o,0);var s;return n(t)&&(s=f.subsample(t,r,o,w)),h.fromPoints(s,i)},h.fromVertices=function(r,o,i,a){if(n(a)||(a=new h),!n(r)||0===r.length)return a.center=t.clone(t.ZERO,a.center),a.radius=0,a;o=e(o,t.ZERO),i=e(i,3);var s=_;s.x=r[0]+o.x,s.y=r[1]+o.y,s.z=r[2]+o.z;for(var u=t.clone(s,d),l=t.clone(s,m),c=t.clone(s,T),E=t.clone(s,R),f=t.clone(s,p),v=t.clone(s,S),I=r.length,O=0;I>O;O+=i){var M=r[O]+o.x,L=r[O+1]+o.y,w=r[O+2]+o.z;s.x=M,s.y=L,s.z=w,M<u.x&&t.clone(s,u),M>E.x&&t.clone(s,E),L<l.y&&t.clone(s,l),L>f.y&&t.clone(s,f),w<c.z&&t.clone(s,c),w>v.z&&t.clone(s,v)}var F=t.magnitudeSquared(t.subtract(E,u,A)),P=t.magnitudeSquared(t.subtract(f,l,A)),D=t.magnitudeSquared(t.subtract(v,c,A)),U=u,x=E,B=F;P>B&&(B=P,U=l,x=f),D>B&&(B=D,U=c,x=v);var b=C;b.x=.5*(U.x+x.x),b.y=.5*(U.y+x.y),b.z=.5*(U.z+x.z);var z=t.magnitudeSquared(t.subtract(x,b,A)),G=Math.sqrt(z),q=g;q.x=u.x,q.y=l.y,q.z=c.z;var H=y;H.x=E.x,H.y=f.y,H.z=v.z;var V=t.multiplyByScalar(t.add(q,H,A),.5,N),W=0;for(O=0;I>O;O+=i){s.x=r[O]+o.x,s.y=r[O+1]+o.y,s.z=r[O+2]+o.z;var Y=t.magnitude(t.subtract(s,V,A));Y>W&&(W=Y);var X=t.magnitudeSquared(t.subtract(s,b,A));if(X>z){var k=Math.sqrt(X);G=.5*(G+k),z=G*G;var K=k-G;b.x=(G*b.x+K*s.x)/k,b.y=(G*b.y+K*s.y)/k,b.z=(G*b.z+K*s.z)/k}}return W>G?(t.clone(b,a.center),a.radius=G):(t.clone(V,a.center),a.radius=W),a},h.fromCornerPoints=function(r,e,o){n(o)||(o=new h);var i=o.center;return t.add(r,e,i),t.multiplyByScalar(i,.5,i),o.radius=t.distance(i,e),o},h.fromEllipsoid=function(r,e){return n(e)||(e=new h),t.clone(t.ZERO,e.center),e.radius=r.maximumRadius,e};var F=new t;h.fromBoundingSpheres=function(r,e){if(n(e)||(e=new h),!n(r)||0===r.length)return e.center=t.clone(t.ZERO,e.center),e.radius=0,e;var o=r.length;if(1===o)return h.clone(r[0],e);if(2===o)return h.union(r[0],r[1],e);for(var i=[],a=0;o>a;a++)i.push(r[a].center);e=h.fromPoints(i,e);var s=e.center,u=e.radius;for(a=0;o>a;a++){var l=r[a];u=Math.max(u,t.distance(s,l.center,F)+l.radius)}return e.radius=u,e},h.clone=function(r,e){return n(r)?n(e)?(e.center=t.clone(r.center,e.center),e.radius=r.radius,e):new h(r.center,r.radius):void 0},h.packedLength=4,h.pack=function(t,r,n){n=e(n,0);var o=t.center;r[n++]=o.x,r[n++]=o.y,r[n++]=o.z,r[n]=t.radius},h.unpack=function(t,r,o){r=e(r,0),n(o)||(o=new h);var i=o.center;return i.x=t[r++],i.y=t[r++],i.z=t[r++],o.radius=t[r],o};var P=new t,D=new t;h.union=function(r,e,o){n(o)||(o=new h);var i=r.center,a=r.radius,s=e.center,u=e.radius,l=t.subtract(s,i,P),c=t.magnitude(l);if(a>=c+u)return r.clone(o),o;if(u>=c+a)return e.clone(o),o;var E=.5*(a+c+u),f=t.multiplyByScalar(l,(-a+E)/c,D);return t.add(f,i,f),t.clone(f,o.center),o.radius=E,o};var U=new t;h.expand=function(r,e,n){n=h.clone(r,n);var o=t.magnitude(t.subtract(e,n.center,U));return o>n.radius&&(n.radius=o),n},h.intersectPlane=function(r,e){var n=r.center,o=r.radius,i=e.normal,a=t.dot(i,n)+e.distance;return-o>a?u.OUTSIDE:o>a?u.INTERSECTING:u.INSIDE},h.transform=function(t,r,e){return n(e)||(e=new h),e.center=c.multiplyByPoint(r,t.center,e.center),e.radius=c.getMaximumScale(r)*t.radius,e};var x=new t;h.distanceSquaredTo=function(r,e){var n=t.subtract(r.center,e,x);return t.magnitudeSquared(n)-r.radius*r.radius},h.transformWithoutScale=function(t,r,e){return n(e)||(e=new h),e.center=c.multiplyByPoint(r,t.center,e.center),e.radius=t.radius,e};var B=new t;h.computePlaneDistances=function(r,e,o,i){n(i)||(i=new l);var a=t.subtract(r.center,e,B),s=t.dot(o,a);return i.start=s-r.radius,i.stop=s+r.radius,i};for(var b=new t,z=new t,G=new t,q=new t,H=new t,V=new r,W=new Array(8),Y=0;8>Y;++Y)W[Y]=new t;var X=new s;return h.projectTo2D=function(r,n,o){n=e(n,X);var i=n.ellipsoid,a=r.center,s=r.radius,u=i.geodeticSurfaceNormal(a,b),l=t.cross(t.UNIT_Z,u,z);t.normalize(l,l);var c=t.cross(u,l,G);t.normalize(c,c),t.multiplyByScalar(u,s,u),t.multiplyByScalar(c,s,c),t.multiplyByScalar(l,s,l);var E=t.negate(c,H),f=t.negate(l,q),d=W,m=d[0];t.add(u,c,m),t.add(m,l,m),m=d[1],t.add(u,c,m),t.add(m,f,m),m=d[2],t.add(u,E,m),t.add(m,f,m),m=d[3],t.add(u,E,m),t.add(m,l,m),t.negate(u,u),m=d[4],t.add(u,c,m),t.add(m,l,m),m=d[5],t.add(u,c,m),t.add(m,f,m),m=d[6],t.add(u,E,m),t.add(m,f,m),m=d[7],t.add(u,E,m),t.add(m,l,m);for(var T=d.length,R=0;T>R;++R){var p=d[R];t.add(a,p,p);var S=i.cartesianToCartographic(p,V);n.project(S,p)}o=h.fromPoints(d,o),a=o.center;var _=a.x,A=a.y,C=a.z;return a.x=C,a.y=_,a.z=A,o},h.isOccluded=function(t,r){return!r.isBoundingSphereVisible(t)},h.equals=function(r,e){return r===e||n(r)&&n(e)&&t.equals(r.center,e.center)&&r.radius===e.radius},h.prototype.intersectPlane=function(t){return h.intersectPlane(this,t)},h.prototype.distanceSquaredTo=function(t){return h.distanceSquaredTo(this,t)},h.prototype.computePlaneDistances=function(t,r,e){return h.computePlaneDistances(this,t,r,e)},h.prototype.isOccluded=function(t){return h.isOccluded(this,t)},h.prototype.equals=function(t){return h.equals(this,t)},h.prototype.clone=function(t){return h.clone(this,t)},h}),define("Core/Fullscreen",["./defined","./defineProperties"],function(t,r){"use strict";var e,n={requestFullscreen:void 0,exitFullscreen:void 0,fullscreenEnabled:void 0,fullscreenElement:void 0,fullscreenchange:void 0,fullscreenerror:void 0},o={};return r(o,{element:{get:function(){return o.supportsFullscreen()?document[n.fullscreenElement]:void 0}},changeEventName:{get:function(){return o.supportsFullscreen()?n.fullscreenchange:void 0}},errorEventName:{get:function(){return o.supportsFullscreen()?n.fullscreenerror:void 0}},enabled:{get:function(){return o.supportsFullscreen()?document[n.fullscreenEnabled]:void 0}},fullscreen:{get:function(){return o.supportsFullscreen()?null!==o.element:void 0}}}),o.supportsFullscreen=function(){if(t(e))return e;e=!1;var r=document.body;if("function"==typeof r.requestFullscreen)return n.requestFullscreen="requestFullscreen",n.exitFullscreen="exitFullscreen",n.fullscreenEnabled="fullscreenEnabled",n.fullscreenElement="fullscreenElement",n.fullscreenchange="fullscreenchange",n.fullscreenerror="fullscreenerror",e=!0;for(var o,i=["webkit","moz","o","ms","khtml"],a=0,s=i.length;s>a;++a){var u=i[a];o=u+"RequestFullscreen","function"==typeof r[o]?(n.requestFullscreen=o,e=!0):(o=u+"RequestFullScreen","function"==typeof r[o]&&(n.requestFullscreen=o,e=!0)),o=u+"ExitFullscreen","function"==typeof document[o]?n.exitFullscreen=o:(o=u+"CancelFullScreen","function"==typeof document[o]&&(n.exitFullscreen=o)),o=u+"FullscreenEnabled",t(document[o])?n.fullscreenEnabled=o:(o=u+"FullScreenEnabled",t(document[o])&&(n.fullscreenEnabled=o)),o=u+"FullscreenElement",t(document[o])?n.fullscreenElement=o:(o=u+"FullScreenElement",t(document[o])&&(n.fullscreenElement=o)),o=u+"fullscreenchange",t(document["on"+o])&&("ms"===u&&(o="MSFullscreenChange"),n.fullscreenchange=o),o=u+"fullscreenerror",t(document["on"+o])&&("ms"===u&&(o="MSFullscreenError"),n.fullscreenerror=o)}return e},o.requestFullscreen=function(t){o.supportsFullscreen()&&t[n.requestFullscreen]()},o.exitFullscreen=function(){o.supportsFullscreen()&&document[n.exitFullscreen]()},o}),define("Core/FeatureDetection",["./defaultValue","./defined","./Fullscreen"],function(t,r,e){"use strict";function n(t){for(var r=t.split("."),e=0,n=r.length;n>e;++e)r[e]=parseInt(r[e],10);return r}function o(){if(!r(T)){T=!1;var t=/ Chrome\/([\.0-9]+)/.exec(navigator.userAgent);null!==t&&(T=!0,R=n(t[1]))}return T}function i(){return o()&&R}function a(){if(!r(p)&&(p=!1,!o()&&/ Safari\/[\.0-9]+/.test(navigator.userAgent))){var t=/ Version\/([\.0-9]+)/.exec(navigator.userAgent);null!==t&&(p=!0,S=n(t[1]))}return p}function s(){return a()&&S}function u(){if(!r(_)){_=!1;var t=/ AppleWebKit\/([\.0-9]+)(\+?)/.exec(navigator.userAgent);null!==t&&(_=!0,A=n(t[1]),A.isNightly=!!t[2])}return _}function l(){return u()&&A}function c(){if(!r(C)){C=!1;var t;"Microsoft Internet Explorer"===navigator.appName?(t=/MSIE ([0-9]{1,}[\.0-9]{0,})/.exec(navigator.userAgent),null!==t&&(C=!0,g=n(t[1]))):"Netscape"===navigator.appName&&(t=/Trident\/.*rv:([0-9]{1,}[\.0-9]{0,})/.exec(navigator.userAgent),null!==t&&(C=!0,g=n(t[1])))}return C}function E(){return c()&&g}function f(){if(!r(y)){y=!1;var t=/Firefox\/([\.0-9]+)/.exec(navigator.userAgent);null!==t&&(y=!0,N=n(t[1]))}return y}function h(){return r(v)||(v=/Windows/i.test(navigator.appVersion)),v}function d(){return f()&&N}function m(){return r(I)||(I=r(window.PointerEvent)&&(!r(window.navigator.pointerEnabled)||window.navigator.pointerEnabled)),I}var T,R,p,S,_,A,C,g,y,N,v,I,O={isChrome:o,chromeVersion:i,isSafari:a,safariVersion:s,isWebkit:u,webkitVersion:l,isInternetExplorer:c,internetExplorerVersion:E,isFirefox:f,firefoxVersion:d,isWindows:h,hardwareConcurrency:t(navigator.hardwareConcurrency,3),supportsPointerEvents:m};return O.supportsFullscreen=function(){return e.supportsFullscreen()},O.supportsTypedArrays=function(){return"undefined"!=typeof ArrayBuffer},O.supportsWebWorkers=function(){return"undefined"!=typeof Worker},O}),define("Core/Color",["./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject","./Math"],function(t,r,e,n,o,i){"use strict";function a(t,r,e){return 0>e&&(e+=1),e>1&&(e-=1),1>6*e?t+6*(r-t)*e:1>2*e?r:2>3*e?t+6*(r-t)*(2/3-e):t}var s=function(r,e,n,o){this.red=t(r,1),this.green=t(e,1),this.blue=t(n,1),this.alpha=t(o,1)};s.fromCartesian4=function(t,e){return r(e)?(e.red=t.x,e.green=t.y,e.blue=t.z,e.alpha=t.w,e):new s(t.x,t.y,t.z,t.w)},s.fromBytes=function(e,n,o,i,a){return e=s.byteToFloat(t(e,255)),n=s.byteToFloat(t(n,255)),o=s.byteToFloat(t(o,255)),i=s.byteToFloat(t(i,255)),r(a)?(a.red=e,a.green=n,a.blue=o,a.alpha=i,a):new s(e,n,o,i)},s.fromAlpha=function(t,e,n){return r(n)?(n.red=t.red,n.green=t.green,n.blue=t.blue,n.alpha=e,n):new s(t.red,t.green,t.blue,e)};var u,l,c;n.supportsTypedArrays()&&(u=new ArrayBuffer(4),l=new Uint32Array(u),c=new Uint8Array(u)),s.fromRgba=function(t){return l[0]=t,s.fromBytes(c[0],c[1],c[2],c[3])},s.fromHsl=function(r,e,n,o){r=t(r,0)%1,e=t(e,0),n=t(n,0),o=t(o,1);var i=n,u=n,l=n;if(0!==e){var c;c=.5>n?n*(1+e):n+e-n*e;var E=2*n-c;i=a(E,c,r+1/3),u=a(E,c,r),l=a(E,c,r-1/3)}return new s(i,u,l,o)},s.fromRandom=function(e,n){e=t(e,t.EMPTY_OBJECT);var o=e.red;if(!r(o)){var a=t(e.minimumRed,0),u=t(e.maximumRed,1);o=a+i.nextRandomNumber()*(u-a)}var l=e.green;if(!r(l)){var c=t(e.minimumGreen,0),E=t(e.maximumGreen,1);l=c+i.nextRandomNumber()*(E-c)}var f=e.blue;if(!r(f)){var h=t(e.minimumBlue,0),d=t(e.maximumBlue,1);f=h+i.nextRandomNumber()*(d-h)}var m=e.alpha;if(!r(m)){var T=t(e.minimumAlpha,0),R=t(e.maximumAlpha,1);m=T+i.nextRandomNumber()*(R-T)}return r(n)?(n.red=o,n.green=l,n.blue=f,n.alpha=m,n):new s(o,l,f,m)};var E=/^#([0-9a-f])([0-9a-f])([0-9a-f])$/i,f=/^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/i,h=/^rgba?\(\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)\s*,\s*([0-9.]+%?)(?:\s*,\s*([0-9.]+))?\s*\)$/i,d=/^hsla?\(\s*([0-9.]+)\s*,\s*([0-9.]+%)\s*,\s*([0-9.]+%)(?:\s*,\s*([0-9.]+))?\s*\)$/i;return s.fromCssColorString=function(e){var n=s[e.toUpperCase()];if(r(n))return s.clone(n);var o=E.exec(e);return null!==o?new s(parseInt(o[1],16)/15,parseInt(o[2],16)/15,parseInt(o[3],16)/15):(o=f.exec(e),null!==o?new s(parseInt(o[1],16)/255,parseInt(o[2],16)/255,parseInt(o[3],16)/255):(o=h.exec(e),null!==o?new s(parseFloat(o[1])/("%"===o[1].substr(-1)?100:255),parseFloat(o[2])/("%"===o[2].substr(-1)?100:255),parseFloat(o[3])/("%"===o[3].substr(-1)?100:255),parseFloat(t(o[4],"1.0"))):(o=d.exec(e),null!==o?s.fromHsl(parseFloat(o[1])/360,parseFloat(o[2])/100,parseFloat(o[3])/100,parseFloat(t(o[4],"1.0"))):void 0)))},s.packedLength=4,s.pack=function(r,e,n){n=t(n,0),e[n++]=r.red,e[n++]=r.green,e[n++]=r.blue,e[n]=r.alpha},s.unpack=function(e,n,o){return n=t(n,0),r(o)||(o=new s),o.red=e[n++],o.green=e[n++],o.blue=e[n++],o.alpha=e[n],o},s.byteToFloat=function(t){return t/255},s.floatToByte=function(t){return 1===t?255:0|256*t},s.clone=function(t,e){return r(t)?r(e)?(e.red=t.red,e.green=t.green,e.blue=t.blue,e.alpha=t.alpha,e):new s(t.red,t.green,t.blue,t.alpha):void 0},s.equals=function(t,e){return t===e||r(t)&&r(e)&&t.red===e.red&&t.green===e.green&&t.blue===e.blue&&t.alpha===e.alpha},s.equalsArray=function(t,r,e){return t.red===r[e]&&t.green===r[e+1]&&t.blue===r[e+2]&&t.alpha===r[e+3]},s.prototype.clone=function(t){return s.clone(this,t)},s.prototype.equals=function(t){return s.equals(this,t)},s.prototype.equalsEpsilon=function(t,e){return this===t||r(t)&&Math.abs(this.red-t.red)<=e&&Math.abs(this.green-t.green)<=e&&Math.abs(this.blue-t.blue)<=e&&Math.abs(this.alpha-t.alpha)<=e},s.prototype.toString=function(){return"("+this.red+", "+this.green+", "+this.blue+", "+this.alpha+")"},s.prototype.toCssColorString=function(){var t=s.floatToByte(this.red),r=s.floatToByte(this.green),e=s.floatToByte(this.blue);return 1===this.alpha?"rgb("+t+","+r+","+e+")":"rgba("+t+","+r+","+e+","+this.alpha+")"},s.prototype.toBytes=function(t){var e=s.floatToByte(this.red),n=s.floatToByte(this.green),o=s.floatToByte(this.blue),i=s.floatToByte(this.alpha);return r(t)?(t[0]=e,t[1]=n,t[2]=o,t[3]=i,t):[e,n,o,i]},s.prototype.toRgba=function(){return c[0]=s.floatToByte(this.red),c[1]=s.floatToByte(this.green),c[2]=s.floatToByte(this.blue),c[3]=s.floatToByte(this.alpha),l[0]},s.prototype.brighten=function(t,r){return t=1-t,r.red=1-(1-this.red)*t,r.green=1-(1-this.green)*t,r.blue=1-(1-this.blue)*t,r.alpha=this.alpha,r},s.prototype.darken=function(t,r){return t=1-t,r.red=this.red*t,r.green=this.green*t,r.blue=this.blue*t,r.alpha=this.alpha,r},s.prototype.withAlpha=function(t,r){return s.fromAlpha(this,t,r)},s.ALICEBLUE=o(s.fromCssColorString("#F0F8FF")),s.ANTIQUEWHITE=o(s.fromCssColorString("#FAEBD7")),s.AQUA=o(s.fromCssColorString("#00FFFF")),s.AQUAMARINE=o(s.fromCssColorString("#7FFFD4")),s.AZURE=o(s.fromCssColorString("#F0FFFF")),s.BEIGE=o(s.fromCssColorString("#F5F5DC")),s.BISQUE=o(s.fromCssColorString("#FFE4C4")),s.BLACK=o(s.fromCssColorString("#000000")),s.BLANCHEDALMOND=o(s.fromCssColorString("#FFEBCD")),s.BLUE=o(s.fromCssColorString("#0000FF")),s.BLUEVIOLET=o(s.fromCssColorString("#8A2BE2")),s.BROWN=o(s.fromCssColorString("#A52A2A")),s.BURLYWOOD=o(s.fromCssColorString("#DEB887")),s.CADETBLUE=o(s.fromCssColorString("#5F9EA0")),s.CHARTREUSE=o(s.fromCssColorString("#7FFF00")),s.CHOCOLATE=o(s.fromCssColorString("#D2691E")),s.CORAL=o(s.fromCssColorString("#FF7F50")),s.CORNFLOWERBLUE=o(s.fromCssColorString("#6495ED")),s.CORNSILK=o(s.fromCssColorString("#FFF8DC")),s.CRIMSON=o(s.fromCssColorString("#DC143C")),s.CYAN=o(s.fromCssColorString("#00FFFF")),s.DARKBLUE=o(s.fromCssColorString("#00008B")),s.DARKCYAN=o(s.fromCssColorString("#008B8B")),s.DARKGOLDENROD=o(s.fromCssColorString("#B8860B")),s.DARKGRAY=o(s.fromCssColorString("#A9A9A9")),s.DARKGREEN=o(s.fromCssColorString("#006400")),s.DARKGREY=s.DARKGRAY,s.DARKKHAKI=o(s.fromCssColorString("#BDB76B")),s.DARKMAGENTA=o(s.fromCssColorString("#8B008B")),s.DARKOLIVEGREEN=o(s.fromCssColorString("#556B2F")),s.DARKORANGE=o(s.fromCssColorString("#FF8C00")),s.DARKORCHID=o(s.fromCssColorString("#9932CC")),s.DARKRED=o(s.fromCssColorString("#8B0000")),s.DARKSALMON=o(s.fromCssColorString("#E9967A")),s.DARKSEAGREEN=o(s.fromCssColorString("#8FBC8F")),s.DARKSLATEBLUE=o(s.fromCssColorString("#483D8B")),s.DARKSLATEGRAY=o(s.fromCssColorString("#2F4F4F")),s.DARKSLATEGREY=s.DARKSLATEGRAY,s.DARKTURQUOISE=o(s.fromCssColorString("#00CED1")),s.DARKVIOLET=o(s.fromCssColorString("#9400D3")),s.DEEPPINK=o(s.fromCssColorString("#FF1493")),s.DEEPSKYBLUE=o(s.fromCssColorString("#00BFFF")),s.DIMGRAY=o(s.fromCssColorString("#696969")),s.DIMGREY=s.DIMGRAY,s.DODGERBLUE=o(s.fromCssColorString("#1E90FF")),s.FIREBRICK=o(s.fromCssColorString("#B22222")),s.FLORALWHITE=o(s.fromCssColorString("#FFFAF0")),s.FORESTGREEN=o(s.fromCssColorString("#228B22")),s.FUSCHIA=o(s.fromCssColorString("#FF00FF")),s.GAINSBORO=o(s.fromCssColorString("#DCDCDC")),s.GHOSTWHITE=o(s.fromCssColorString("#F8F8FF")),s.GOLD=o(s.fromCssColorString("#FFD700")),s.GOLDENROD=o(s.fromCssColorString("#DAA520")),s.GRAY=o(s.fromCssColorString("#808080")),s.GREEN=o(s.fromCssColorString("#008000")),s.GREENYELLOW=o(s.fromCssColorString("#ADFF2F")),s.GREY=s.GRAY,s.HONEYDEW=o(s.fromCssColorString("#F0FFF0")),s.HOTPINK=o(s.fromCssColorString("#FF69B4")),s.INDIANRED=o(s.fromCssColorString("#CD5C5C")),s.INDIGO=o(s.fromCssColorString("#4B0082")),s.IVORY=o(s.fromCssColorString("#FFFFF0")),s.KHAKI=o(s.fromCssColorString("#F0E68C")),s.LAVENDER=o(s.fromCssColorString("#E6E6FA")),s.LAVENDAR_BLUSH=o(s.fromCssColorString("#FFF0F5")),s.LAWNGREEN=o(s.fromCssColorString("#7CFC00")),s.LEMONCHIFFON=o(s.fromCssColorString("#FFFACD")),s.LIGHTBLUE=o(s.fromCssColorString("#ADD8E6")),s.LIGHTCORAL=o(s.fromCssColorString("#F08080")),s.LIGHTCYAN=o(s.fromCssColorString("#E0FFFF")),s.LIGHTGOLDENRODYELLOW=o(s.fromCssColorString("#FAFAD2")),s.LIGHTGRAY=o(s.fromCssColorString("#D3D3D3")),s.LIGHTGREEN=o(s.fromCssColorString("#90EE90")),s.LIGHTGREY=s.LIGHTGRAY,s.LIGHTPINK=o(s.fromCssColorString("#FFB6C1")),s.LIGHTSEAGREEN=o(s.fromCssColorString("#20B2AA")),s.LIGHTSKYBLUE=o(s.fromCssColorString("#87CEFA")),s.LIGHTSLATEGRAY=o(s.fromCssColorString("#778899")),s.LIGHTSLATEGREY=s.LIGHTSLATEGRAY,s.LIGHTSTEELBLUE=o(s.fromCssColorString("#B0C4DE")),s.LIGHTYELLOW=o(s.fromCssColorString("#FFFFE0")),s.LIME=o(s.fromCssColorString("#00FF00")),s.LIMEGREEN=o(s.fromCssColorString("#32CD32")),s.LINEN=o(s.fromCssColorString("#FAF0E6")),s.MAGENTA=o(s.fromCssColorString("#FF00FF")),s.MAROON=o(s.fromCssColorString("#800000")),s.MEDIUMAQUAMARINE=o(s.fromCssColorString("#66CDAA")),s.MEDIUMBLUE=o(s.fromCssColorString("#0000CD")),s.MEDIUMORCHID=o(s.fromCssColorString("#BA55D3")),s.MEDIUMPURPLE=o(s.fromCssColorString("#9370DB")),s.MEDIUMSEAGREEN=o(s.fromCssColorString("#3CB371")),s.MEDIUMSLATEBLUE=o(s.fromCssColorString("#7B68EE")),s.MEDIUMSPRINGGREEN=o(s.fromCssColorString("#00FA9A")),s.MEDIUMTURQUOISE=o(s.fromCssColorString("#48D1CC")),s.MEDIUMVIOLETRED=o(s.fromCssColorString("#C71585")),s.MIDNIGHTBLUE=o(s.fromCssColorString("#191970")),s.MINTCREAM=o(s.fromCssColorString("#F5FFFA")),s.MISTYROSE=o(s.fromCssColorString("#FFE4E1")),s.MOCCASIN=o(s.fromCssColorString("#FFE4B5")),s.NAVAJOWHITE=o(s.fromCssColorString("#FFDEAD")),s.NAVY=o(s.fromCssColorString("#000080")),s.OLDLACE=o(s.fromCssColorString("#FDF5E6")),s.OLIVE=o(s.fromCssColorString("#808000")),s.OLIVEDRAB=o(s.fromCssColorString("#6B8E23")),s.ORANGE=o(s.fromCssColorString("#FFA500")),s.ORANGERED=o(s.fromCssColorString("#FF4500")),s.ORCHID=o(s.fromCssColorString("#DA70D6")),s.PALEGOLDENROD=o(s.fromCssColorString("#EEE8AA")),s.PALEGREEN=o(s.fromCssColorString("#98FB98")),s.PALETURQUOISE=o(s.fromCssColorString("#AFEEEE")),s.PALEVIOLETRED=o(s.fromCssColorString("#DB7093")),s.PAPAYAWHIP=o(s.fromCssColorString("#FFEFD5")),s.PEACHPUFF=o(s.fromCssColorString("#FFDAB9")),s.PERU=o(s.fromCssColorString("#CD853F")),s.PINK=o(s.fromCssColorString("#FFC0CB")),s.PLUM=o(s.fromCssColorString("#DDA0DD")),s.POWDERBLUE=o(s.fromCssColorString("#B0E0E6")),s.PURPLE=o(s.fromCssColorString("#800080")),s.RED=o(s.fromCssColorString("#FF0000")),s.ROSYBROWN=o(s.fromCssColorString("#BC8F8F")),s.ROYALBLUE=o(s.fromCssColorString("#4169E1")),s.SADDLEBROWN=o(s.fromCssColorString("#8B4513")),s.SALMON=o(s.fromCssColorString("#FA8072")),s.SANDYBROWN=o(s.fromCssColorString("#F4A460")),s.SEAGREEN=o(s.fromCssColorString("#2E8B57")),s.SEASHELL=o(s.fromCssColorString("#FFF5EE")),s.SIENNA=o(s.fromCssColorString("#A0522D")),s.SILVER=o(s.fromCssColorString("#C0C0C0")),s.SKYBLUE=o(s.fromCssColorString("#87CEEB")),s.SLATEBLUE=o(s.fromCssColorString("#6A5ACD")),s.SLATEGRAY=o(s.fromCssColorString("#708090")),s.SLATEGREY=s.SLATEGRAY,s.SNOW=o(s.fromCssColorString("#FFFAFA")),s.SPRINGGREEN=o(s.fromCssColorString("#00FF7F")),s.STEELBLUE=o(s.fromCssColorString("#4682B4")),s.TAN=o(s.fromCssColorString("#D2B48C")),s.TEAL=o(s.fromCssColorString("#008080")),s.THISTLE=o(s.fromCssColorString("#D8BFD8")),s.TOMATO=o(s.fromCssColorString("#FF6347")),s.TURQUOISE=o(s.fromCssColorString("#40E0D0")),s.VIOLET=o(s.fromCssColorString("#EE82EE")),s.WHEAT=o(s.fromCssColorString("#F5DEB3")),s.WHITE=o(s.fromCssColorString("#FFFFFF")),s.WHITESMOKE=o(s.fromCssColorString("#F5F5F5")),s.YELLOW=o(s.fromCssColorString("#FFFF00")),s.YELLOWGREEN=o(s.fromCssColorString("#9ACD32")),s.TRANSPARENT=o(new s(0,0,0,0)),s
}),define("Renderer/WebGLConstants",["../Core/freezeObject"],function(t){"use strict";var r={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,FUNC_ADD:32774,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,BLEND_COLOR:32773,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,STREAM_DRAW:35040,STATIC_DRAW:35044,DYNAMIC_DRAW:35048,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,CULL_FACE:2884,BLEND:3042,DITHER:3024,STENCIL_TEST:2960,DEPTH_TEST:2929,SCISSOR_TEST:3089,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CW:2304,CCW:2305,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_UNIFORMS:35718,ACTIVE_ATTRIBUTES:35721,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,NOTEQUAL:517,GEQUAL:518,ALWAYS:519,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,VENDOR:7936,RENDERER:7937,VERSION:7938,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,TEXTURE1:33985,TEXTURE2:33986,TEXTURE3:33987,TEXTURE4:33988,TEXTURE5:33989,TEXTURE6:33990,TEXTURE7:33991,TEXTURE8:33992,TEXTURE9:33993,TEXTURE10:33994,TEXTURE11:33995,TEXTURE12:33996,TEXTURE13:33997,TEXTURE14:33998,TEXTURE15:33999,TEXTURE16:34e3,TEXTURE17:34001,TEXTURE18:34002,TEXTURE19:34003,TEXTURE20:34004,TEXTURE21:34005,TEXTURE22:34006,TEXTURE23:34007,TEXTURE24:34008,TEXTURE25:34009,TEXTURE26:34010,TEXTURE27:34011,TEXTURE28:34012,TEXTURE29:34013,TEXTURE30:34014,TEXTURE31:34015,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,COMPILE_STATUS:35713,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,CONTEXT_LOST_WEBGL:37442,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,BROWSER_DEFAULT_WEBGL:37444,UNSIGNED_INT_24_8_WEBGL:34042,DOUBLE:5130};return t(r)}),define("Core/ComponentDatatype",["../Renderer/WebGLConstants","./defaultValue","./defined","./DeveloperError","./FeatureDetection","./freezeObject"],function(t,r,e,n,o,i){"use strict";if(!o.supportsTypedArrays())return{};var a={BYTE:t.BYTE,UNSIGNED_BYTE:t.UNSIGNED_BYTE,SHORT:t.SHORT,UNSIGNED_SHORT:t.UNSIGNED_SHORT,FLOAT:t.FLOAT,DOUBLE:t.DOUBLE};return a.getSizeInBytes=function(t){switch(t){case a.BYTE:return Int8Array.BYTES_PER_ELEMENT;case a.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case a.SHORT:return Int16Array.BYTES_PER_ELEMENT;case a.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case a.FLOAT:return Float32Array.BYTES_PER_ELEMENT;case a.DOUBLE:return Float64Array.BYTES_PER_ELEMENT;default:throw new n("componentDatatype is not a valid value.")}},a.fromTypedArray=function(t){return t instanceof Int8Array?a.BYTE:t instanceof Uint8Array?a.UNSIGNED_BYTE:t instanceof Int16Array?a.SHORT:t instanceof Uint16Array?a.UNSIGNED_SHORT:t instanceof Float32Array?a.FLOAT:t instanceof Float64Array?a.DOUBLE:void 0},a.validate=function(t){return e(t)&&(t===a.BYTE||t===a.UNSIGNED_BYTE||t===a.SHORT||t===a.UNSIGNED_SHORT||t===a.FLOAT||t===a.DOUBLE)},a.createTypedArray=function(t,r){switch(t){case a.BYTE:return new Int8Array(r);case a.UNSIGNED_BYTE:return new Uint8Array(r);case a.SHORT:return new Int16Array(r);case a.UNSIGNED_SHORT:return new Uint16Array(r);case a.FLOAT:return new Float32Array(r);case a.DOUBLE:return new Float64Array(r);default:throw new n("componentDatatype is not a valid value.")}},a.createArrayBufferView=function(t,e,o,i){switch(o=r(o,0),i=r(i,(e.byteLength-o)/a.getSizeInBytes(t)),t){case a.BYTE:return new Int8Array(e,o,i);case a.UNSIGNED_BYTE:return new Uint8Array(e,o,i);case a.SHORT:return new Int16Array(e,o,i);case a.UNSIGNED_SHORT:return new Uint16Array(e,o,i);case a.FLOAT:return new Float32Array(e,o,i);case a.DOUBLE:return new Float64Array(e,o,i);default:throw new n("componentDatatype is not a valid value.")}},i(a)}),define("Core/GeometryType",["./freezeObject"],function(t){"use strict";var r={NONE:0,TRIANGLES:1,LINES:2,POLYLINES:3};return t(r)}),define("Core/PrimitiveType",["../Renderer/WebGLConstants","./freezeObject"],function(t,r){"use strict";var e={POINTS:t.POINTS,LINES:t.LINES,LINE_LOOP:t.LINE_LOOP,LINE_STRIP:t.LINE_STRIP,TRIANGLES:t.TRIANGLES,TRIANGLE_STRIP:t.TRIANGLE_STRIP,TRIANGLE_FAN:t.TRIANGLE_FAN,validate:function(t){return t===e.POINTS||t===e.LINES||t===e.LINE_LOOP||t===e.LINE_STRIP||t===e.TRIANGLES||t===e.TRIANGLE_STRIP||t===e.TRIANGLE_FAN}};return r(e)}),define("Core/Geometry",["./defaultValue","./defined","./DeveloperError","./GeometryType","./PrimitiveType"],function(t,r,e,n,o){"use strict";var i=function(r){r=t(r,t.EMPTY_OBJECT),this.attributes=r.attributes,this.indices=r.indices,this.primitiveType=t(r.primitiveType,o.TRIANGLES),this.boundingSphere=r.boundingSphere,this.geometryType=t(r.geometryType,n.NONE),this.boundingSphereCV=void 0};return i.computeNumberOfVertices=function(t){var n=-1;for(var o in t.attributes)if(t.attributes.hasOwnProperty(o)&&r(t.attributes[o])&&r(t.attributes[o].values)){var i=t.attributes[o],a=i.values.length/i.componentsPerAttribute;if(n!==a&&-1!==n)throw new e("All attribute lists must have the same number of attributes.");n=a}return n},i}),define("Core/GeometryAttribute",["./defaultValue","./defined","./DeveloperError"],function(t){"use strict";var r=function(r){r=t(r,t.EMPTY_OBJECT),this.componentDatatype=r.componentDatatype,this.componentsPerAttribute=r.componentsPerAttribute,this.normalize=t(r.normalize,!1),this.values=r.values};return r}),define("Core/GeometryAttributes",["./defaultValue"],function(t){"use strict";var r=function(r){r=t(r,t.EMPTY_OBJECT),this.position=r.position,this.normal=r.normal,this.st=r.st,this.binormal=r.binormal,this.tangent=r.tangent,this.color=r.color};return r}),define("Core/IndexDatatype",["../Renderer/WebGLConstants","./defined","./DeveloperError","./freezeObject","./Math"],function(t,r,e,n,o){"use strict";var i={UNSIGNED_BYTE:t.UNSIGNED_BYTE,UNSIGNED_SHORT:t.UNSIGNED_SHORT,UNSIGNED_INT:t.UNSIGNED_INT};return i.getSizeInBytes=function(t){switch(t){case i.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case i.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case i.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT}},i.validate=function(t){return r(t)&&(t===i.UNSIGNED_BYTE||t===i.UNSIGNED_SHORT||t===i.UNSIGNED_INT)},i.createTypedArray=function(t,r){return t>o.SIXTY_FOUR_KILOBYTES?new Uint32Array(r):new Uint16Array(r)},i.createTypedArrayFromArrayBuffer=function(t,r,e,n){return t>o.SIXTY_FOUR_KILOBYTES?new Uint32Array(r,e,n):new Uint16Array(r,e,n)},n(i)}),define("Core/EllipsoidGeodesic",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./Ellipsoid","./Math"],function(t,r,e,n,o,i,a,s){"use strict";function u(t){var r=t._uSquared,e=t._ellipsoid.maximumRadius,n=t._ellipsoid.minimumRadius,o=(e-n)/e,i=Math.cos(t._startHeading),a=Math.sin(t._startHeading),s=(1-o)*Math.tan(t._start.latitude),u=1/Math.sqrt(1+s*s),l=u*s,c=Math.atan2(s,i),E=u*a,f=E*E,h=1-f,d=Math.sqrt(h),m=r/4,T=m*m,R=T*m,p=T*T,S=1+m-3*T/4+5*R/4-175*p/64,_=1-m+15*T/8-35*R/8,A=1-3*m+35*T/4,C=1-5*m,g=S*c-_*Math.sin(2*c)*m/2-A*Math.sin(4*c)*T/16-C*Math.sin(6*c)*R/48-5*Math.sin(8*c)*p/512,y=t._constants;y.a=e,y.b=n,y.f=o,y.cosineHeading=i,y.sineHeading=a,y.tanU=s,y.cosineU=u,y.sineU=l,y.sigma=c,y.sineAlpha=E,y.sineSquaredAlpha=f,y.cosineSquaredAlpha=h,y.cosineAlpha=d,y.u2Over4=m,y.u4Over16=T,y.u6Over64=R,y.u8Over256=p,y.a0=S,y.a1=_,y.a2=A,y.a3=C,y.distanceRatio=g}function l(t,r){return t*r*(4+t*(4-3*r))/16}function c(t,r,e,n,o,i,a){var s=l(t,e);return(1-s)*t*r*(n+s*o*(a+s*i*(2*a*a-1)))}function E(t,r,e,n,o,i,a){var u,l,E,f,h,d=(r-e)/r,m=i-n,T=Math.atan((1-d)*Math.tan(o)),R=Math.atan((1-d)*Math.tan(a)),p=Math.cos(T),S=Math.sin(T),_=Math.cos(R),A=Math.sin(R),C=p*_,g=p*A,y=S*A,N=S*_,v=m,I=s.TWO_PI,O=Math.cos(v),M=Math.sin(v);do{O=Math.cos(v),M=Math.sin(v);var L=g-N*O;E=Math.sqrt(_*_*M*M+L*L),l=y+C*O,u=Math.atan2(E,l);var w;0===E?(w=0,f=1):(w=C*M/E,f=1-w*w),I=v,h=l-2*y/f,isNaN(h)&&(h=0),v=m+c(d,w,f,u,E,l,h)}while(Math.abs(v-I)>s.EPSILON12);var F=f*(r*r-e*e)/(e*e),P=1+F*(4096+F*(F*(320-175*F)-768))/16384,D=F*(256+F*(F*(74-47*F)-128))/1024,U=h*h,x=D*E*(h+D*(l*(2*U-1)-D*h*(4*E*E-3)*(4*U-3)/6)/4),B=e*P*(u-x),b=Math.atan2(_*M,g-N*O),z=Math.atan2(p*M,g*O-N);t._distance=B,t._startHeading=b,t._endHeading=z,t._uSquared=F}function f(e,n,o,i){t.normalize(i.cartographicToCartesian(n,d),h),t.normalize(i.cartographicToCartesian(o,d),d),E(e,i.maximumRadius,i.minimumRadius,n.longitude,n.latitude,o.longitude,o.latitude),e._start=r.clone(n,e._start),e._end=r.clone(o,e._end),e._start.height=0,e._end.height=0,u(e)}var h=new t,d=new t,m=function(t,o,i){var s=e(i,a.WGS84);this._ellipsoid=s,this._start=new r,this._end=new r,this._constants={},this._startHeading=void 0,this._endHeading=void 0,this._distance=void 0,this._uSquared=void 0,n(t)&&n(o)&&f(this,t,o,s)};return o(m.prototype,{ellipsoid:{get:function(){return this._ellipsoid}},surfaceDistance:{get:function(){return this._distance}},start:{get:function(){return this._start}},end:{get:function(){return this._end}},startHeading:{get:function(){return this._startHeading}},endHeading:{get:function(){return this._endHeading}}}),m.prototype.setEndPoints=function(t,r){f(this,t,r,this._ellipsoid)},m.prototype.interpolateUsingFraction=function(t,r){return this.interpolateUsingSurfaceDistance(this._distance*t,r)},m.prototype.interpolateUsingSurfaceDistance=function(t,e){var o=this._constants,i=o.distanceRatio+t/o.b,a=Math.cos(2*i),s=Math.cos(4*i),u=Math.cos(6*i),l=Math.sin(2*i),E=Math.sin(4*i),f=Math.sin(6*i),h=Math.sin(8*i),d=i*i,m=i*d,T=o.u8Over256,R=o.u2Over4,p=o.u6Over64,S=o.u4Over16,_=2*m*T*a/3+i*(1-R+7*S/4-15*p/4+579*T/64-(S-15*p/4+187*T/16)*a-(5*p/4-115*T/16)*s-29*T*u/16)+(R/2-S+71*p/32-85*T/16)*l+(5*S/16-5*p/4+383*T/96)*E-d*((p-11*T/2)*l+5*T*E/2)+(29*p/96-29*T/16)*f+539*T*h/1536,A=Math.asin(Math.sin(_)*o.cosineAlpha),C=Math.atan(o.a/o.b*Math.tan(A));_-=o.sigma;var g=Math.cos(2*o.sigma+_),y=Math.sin(_),N=Math.cos(_),v=o.cosineU*N,I=o.sineU*y,O=Math.atan2(y*o.sineHeading,v-I*o.cosineHeading),M=O-c(o.f,o.sineAlpha,o.cosineSquaredAlpha,_,y,N,g);return n(e)?(e.longitude=this._start.longitude+M,e.latitude=C,e.height=0,e):new r(this._start.longitude+M,C,0)},m}),define("Core/QuadraticRealPolynomial",["./DeveloperError","./Math"],function(t,r){"use strict";function e(t,e,n){var o=t+e;return r.sign(t)!==r.sign(e)&&Math.abs(o/Math.max(Math.abs(t),Math.abs(e)))<n?0:o}var n={};return n.computeDiscriminant=function(t,r,e){var n=r*r-4*t*e;return n},n.computeRealRoots=function(t,n,o){var i;if(0===t)return 0===n?[]:[-o/n];if(0===n){if(0===o)return[0,0];var a=Math.abs(o),s=Math.abs(t);if(s>a&&a/s<r.EPSILON14)return[0,0];if(a>s&&s/a<r.EPSILON14)return[];if(i=-o/t,0>i)return[];var u=Math.sqrt(i);return[-u,u]}if(0===o)return i=-n/t,0>i?[i,0]:[0,i];var l=n*n,c=4*t*o,E=e(l,-c,r.EPSILON14);if(0>E)return[];var f=-.5*e(n,r.sign(n)*Math.sqrt(E),r.EPSILON14);return n>0?[f/t,o/f]:[o/f,f/t]},n}),define("Core/CubicRealPolynomial",["./DeveloperError","./QuadraticRealPolynomial"],function(t,r){"use strict";function e(t,r,e,n){var o,i,a=t,s=r/3,u=e/3,l=n,c=a*u,E=s*l,f=s*s,h=u*u,d=a*u-f,m=a*l-s*u,T=s*l-h,R=4*d*T-m*m;if(0>R){var p,S,_;f*E>=c*h?(p=a,S=d,_=-2*s*d+a*m):(p=l,S=T,_=-l*m+2*u*T);var A=0>_?-1:1,C=-A*Math.abs(p)*Math.sqrt(-R);i=-_+C;var g=i/2,y=0>g?-Math.pow(-g,1/3):Math.pow(g,1/3),N=i===C?-y:-S/y;return o=0>=S?y+N:-_/(y*y+N*N+S),f*E>=c*h?[(o-s)/a]:[-l/(o+u)]}var v=d,I=-2*s*d+a*m,O=T,M=-l*m+2*u*T,L=Math.sqrt(R),w=Math.sqrt(3)/2,F=Math.abs(Math.atan2(a*L,-I)/3);o=2*Math.sqrt(-v);var P=Math.cos(F);i=o*P;var D=o*(-P/2-w*Math.sin(F)),U=i+D>2*s?i-s:D-s,x=a,B=U/x;F=Math.abs(Math.atan2(l*L,-M)/3),o=2*Math.sqrt(-O),P=Math.cos(F),i=o*P,D=o*(-P/2-w*Math.sin(F));var b=-l,z=2*u>i+D?i+u:D+u,G=b/z,q=x*z,H=-U*z-x*b,V=U*b,W=(u*H-s*V)/(-s*H+u*q);return W>=B?G>=B?G>=W?[B,W,G]:[B,G,W]:[G,B,W]:G>=B?[W,B,G]:G>=W?[W,G,B]:[G,W,B]}var n={};return n.computeDiscriminant=function(t,r,e,n){var o=t*t,i=r*r,a=e*e,s=n*n,u=18*t*r*e*n+i*a-27*o*s-4*(t*a*e+i*r*n);return u},n.computeRealRoots=function(t,n,o,i){var a,s;if(0===t)return r.computeRealRoots(n,o,i);if(0===n){if(0===o){if(0===i)return[0,0,0];s=-i/t;var u=0>s?-Math.pow(-s,1/3):Math.pow(s,1/3);return[u,u,u]}return 0===i?(a=r.computeRealRoots(t,0,o),0===a.Length?[0]:[a[0],0,a[1]]):e(t,0,o,i)}return 0===o?0===i?(s=-n/t,0>s?[s,0,0]:[0,0,s]):e(t,n,0,i):0===i?(a=r.computeRealRoots(t,n,o),0===a.length?[0]:a[1]<=0?[a[0],a[1],0]:a[0]>=0?[0,a[0],a[1]]:[a[0],0,a[1]]):e(t,n,o,i)},n}),define("Core/QuarticRealPolynomial",["./CubicRealPolynomial","./DeveloperError","./Math","./QuadraticRealPolynomial"],function(t,r,e,n){"use strict";function o(r,o,i,a){var s=r*r,u=o-3*s/8,l=i-o*r/2+s*r/8,c=a-i*r/4+o*s/16-3*s*s/256,E=t.computeRealRoots(1,2*u,u*u-4*c,-l*l);if(E.length>0){var f=-r/4,h=E[E.length-1];if(Math.abs(h)<e.EPSILON14){var d=n.computeRealRoots(1,u,c);if(2===d.length){var m,T=d[0],R=d[1];if(T>=0&&R>=0){var p=Math.sqrt(T),S=Math.sqrt(R);return[f-S,f-p,f+p,f+S]}if(T>=0&&0>R)return m=Math.sqrt(T),[f-m,f+m];if(0>T&&R>=0)return m=Math.sqrt(R),[f-m,f+m]}return[]}if(h>0){var _=Math.sqrt(h),A=(u+h-l/_)/2,C=(u+h+l/_)/2,g=n.computeRealRoots(1,_,A),y=n.computeRealRoots(1,-_,C);return 0!==g.length?(g[0]+=f,g[1]+=f,0!==y.length?(y[0]+=f,y[1]+=f,g[1]<=y[0]?[g[0],g[1],y[0],y[1]]:y[1]<=g[0]?[y[0],y[1],g[0],g[1]]:g[0]>=y[0]&&g[1]<=y[1]?[y[0],g[0],g[1],y[1]]:y[0]>=g[0]&&y[1]<=g[1]?[g[0],y[0],y[1],g[1]]:g[0]>y[0]&&g[0]<y[1]?[y[0],g[0],y[1],g[1]]:[g[0],y[0],g[1],y[1]]):g):0!==y.length?(y[0]+=f,y[1]+=f,y):[]}}return[]}function i(r,o,i,a){var s=i*i,u=o*o,l=r*r,c=-2*o,E=i*r+u-4*a,f=l*a-i*o*r+s,h=t.computeRealRoots(1,c,E,f);if(h.length>0){var d,m,T=h[0],R=o-T,p=R*R,S=r/2,_=R/2,A=p-4*a,C=p+4*Math.abs(a),g=l-4*T,y=l+4*Math.abs(T);if(0>T||g*C>A*y){var N=Math.sqrt(g);d=N/2,m=0===N?0:(r*_-i)/N}else{var v=Math.sqrt(A);d=0===v?0:(r*_-i)/v,m=v/2}var I,O;0===S&&0===d?(I=0,O=0):e.sign(S)===e.sign(d)?(I=S+d,O=T/I):(O=S-d,I=T/O);var M,L;0===_&&0===m?(M=0,L=0):e.sign(_)===e.sign(m)?(M=_+m,L=a/M):(L=_-m,M=a/L);var w=n.computeRealRoots(1,I,M),F=n.computeRealRoots(1,O,L);if(0!==w.length)return 0!==F.length?w[1]<=F[0]?[w[0],w[1],F[0],F[1]]:F[1]<=w[0]?[F[0],F[1],w[0],w[1]]:w[0]>=F[0]&&w[1]<=F[1]?[F[0],w[0],w[1],F[1]]:F[0]>=w[0]&&F[1]<=w[1]?[w[0],F[0],F[1],w[1]]:w[0]>F[0]&&w[0]<F[1]?[F[0],w[0],F[1],w[1]]:[w[0],F[0],w[1],F[1]]:w;if(0!==F.length)return F}return[]}var a={};return a.computeDiscriminant=function(t,r,e,n,o){var i=t*t,a=i*t,s=r*r,u=s*r,l=e*e,c=l*e,E=n*n,f=E*n,h=o*o,d=h*o,m=s*l*E-4*u*f-4*t*c*E+18*t*r*e*f-27*i*E*E+256*a*d+o*(18*u*e*n-4*s*c+16*t*l*l-80*t*r*l*n-6*t*s*E+144*i*e*E)+h*(144*t*s*e-27*s*s-128*i*l-192*i*r*n);return m},a.computeRealRoots=function(r,n,a,s,u){if(Math.abs(r)<e.EPSILON15)return t.computeRealRoots(n,a,s,u);var l=n/r,c=a/r,E=s/r,f=u/r,h=0>l?1:0;switch(h+=0>c?h+1:h,h+=0>E?h+1:h,h+=0>f?h+1:h){case 0:return o(l,c,E,f);case 1:return i(l,c,E,f);case 2:return i(l,c,E,f);case 3:return o(l,c,E,f);case 4:return o(l,c,E,f);case 5:return i(l,c,E,f);case 6:return o(l,c,E,f);case 7:return o(l,c,E,f);case 8:return i(l,c,E,f);case 9:return o(l,c,E,f);case 10:return o(l,c,E,f);case 11:return i(l,c,E,f);case 12:return o(l,c,E,f);case 13:return o(l,c,E,f);case 14:return o(l,c,E,f);case 15:return o(l,c,E,f);default:return void 0}},a}),define("Core/Ray",["./Cartesian3","./defaultValue","./defined","./DeveloperError"],function(t,r,e){"use strict";var n=function(e,n){n=t.clone(r(n,t.ZERO)),t.equals(n,t.ZERO)||t.normalize(n,n),this.origin=t.clone(r(e,t.ZERO)),this.direction=n};return n.getPoint=function(r,n,o){return e(o)||(o=new t),o=t.multiplyByScalar(r.direction,n,o),t.add(r.origin,o,o)},n}),define("Core/IntersectionTests",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Math","./Matrix3","./QuadraticRealPolynomial","./QuarticRealPolynomial","./Ray"],function(t,r,e,n,o,i,a,s,u,l){"use strict";function c(r,n,o,a,s){s=e(s,!1);var u,l,c,E,f,h=r.origin,d=r.direction,m=t.subtract(o,n,T),A=t.subtract(a,n,R),C=t.cross(d,A,p),g=t.dot(m,C);if(s){if(g<i.EPSILON6)return void 0;if(u=t.subtract(h,n,S),c=t.dot(u,C),0>c||c>g)return void 0;if(l=t.cross(u,m,_),E=t.dot(d,l),0>E||c+E>g)return void 0;f=t.dot(A,l)/g}else{if(Math.abs(g)<i.EPSILON6)return void 0;var y=1/g;if(u=t.subtract(h,n,S),c=t.dot(u,C)*y,0>c||c>1)return void 0;if(l=t.cross(u,m,_),E=t.dot(d,l)*y,0>E||c+E>1)return void 0;f=t.dot(A,l)*y}return f}function E(t,r,e,n){var o=r*r-4*t*e;if(0>o)return void 0;if(o>0){var i=1/(2*t),a=Math.sqrt(o),s=(-r+a)*i,u=(-r-a)*i;return u>s?(n.root0=s,n.root1=u):(n.root0=u,n.root1=s),n}var l=-r/(2*t);return 0===l?void 0:(n.root0=n.root1=l,n)}function f(r,e,o){n(o)||(o={});var i=r.origin,a=r.direction,s=e.center,u=e.radius*e.radius,l=t.subtract(i,s,p),c=t.dot(a,a),f=2*t.dot(a,l),h=t.magnitudeSquared(l)-u,d=E(c,f,h,C);return n(d)?(o.start=d.root0,o.stop=d.root1,o):void 0}function h(t,r,e){var n=t+r;return i.sign(t)!==i.sign(r)&&Math.abs(n/Math.max(Math.abs(t),Math.abs(r)))<e?0:n}function d(r,e,n,o,l){var c,E=o*o,f=l*l,d=(r[a.COLUMN1ROW1]-r[a.COLUMN2ROW2])*f,m=l*(o*h(r[a.COLUMN1ROW0],r[a.COLUMN0ROW1],i.EPSILON15)+e.y),T=r[a.COLUMN0ROW0]*E+r[a.COLUMN2ROW2]*f+o*e.x+n,R=f*h(r[a.COLUMN2ROW1],r[a.COLUMN1ROW2],i.EPSILON15),p=l*(o*h(r[a.COLUMN2ROW0],r[a.COLUMN0ROW2])+e.z),S=[];if(0===p&&0===R){if(c=s.computeRealRoots(d,m,T),0===c.length)return S;var _=c[0],A=Math.sqrt(Math.max(1-_*_,0));if(S.push(new t(o,l*_,l*-A)),S.push(new t(o,l*_,l*A)),2===c.length){var C=c[1],g=Math.sqrt(Math.max(1-C*C,0));S.push(new t(o,l*C,l*-g)),S.push(new t(o,l*C,l*g))}return S}var y=p*p,N=R*R,v=d*d,I=p*R,O=v+N,M=2*(m*d+I),L=2*T*d+m*m-N+y,w=2*(T*m-I),F=T*T-y;if(0===O&&0===M&&0===L&&0===w)return S;c=u.computeRealRoots(O,M,L,w,F);var P=c.length;if(0===P)return S;for(var D=0;P>D;++D){var U,x=c[D],B=x*x,b=Math.max(1-B,0),z=Math.sqrt(b);U=i.sign(d)===i.sign(T)?h(d*B+T,m*x,i.EPSILON12):i.sign(T)===i.sign(m*x)?h(d*B,m*x+T,i.EPSILON12):h(d*B+m*x,T,i.EPSILON12);var G=h(R*x,p,i.EPSILON15),q=U*G;0>q?S.push(new t(o,l*x,l*z)):q>0?S.push(new t(o,l*x,l*-z)):0!==z?(S.push(new t(o,l*x,l*-z)),S.push(new t(o,l*x,l*z)),++D):S.push(new t(o,l*x,l*z))}return S}var m={};m.rayPlane=function(r,e,o){n(o)||(o=new t);var a=r.origin,s=r.direction,u=e.normal,l=t.dot(u,s);if(Math.abs(l)<i.EPSILON15)return void 0;var c=(-e.distance-t.dot(u,a))/l;return 0>c?void 0:(o=t.multiplyByScalar(s,c,o),t.add(a,o,o))};var T=new t,R=new t,p=new t,S=new t,_=new t;m.rayTriangle=function(r,e,o,i,a,s){var u=c(r,e,o,i,a);return!n(u)||0>u?void 0:(n(s)||(s=new t),t.multiplyByScalar(r.direction,u,s),t.add(r.origin,s,s))};var A=new l;m.lineSegmentTriangle=function(r,e,o,i,a,s,u){var l=A;t.clone(r,l.origin),t.subtract(e,r,l.direction),t.normalize(l.direction,l.direction);var E=c(l,o,i,a,s);return!n(E)||0>E||E>t.distance(r,e)?void 0:(n(u)||(u=new t),t.multiplyByScalar(l.direction,E,u),t.add(l.origin,u,u))};var C={root0:0,root1:0};m.raySphere=function(t,r,e){return e=f(t,r,e),!n(e)||e.stop<0?void 0:(e.start=Math.max(e.start,0),e)};var g=new l;m.lineSegmentSphere=function(r,e,o,i){var a=g;t.clone(r,a.origin);var s=t.subtract(e,r,a.direction),u=t.magnitude(s);return t.normalize(s,s),i=f(a,o,i),!n(i)||i.stop<0||i.start>u?void 0:(i.start=Math.max(i.start,0),i.stop=Math.min(i.stop,u),i)};var y=new t,N=new t;m.rayEllipsoid=function(r,e){var n,o,i,a,s,u=e.oneOverRadii,l=t.multiplyComponents(u,r.origin,y),c=t.multiplyComponents(u,r.direction,N),E=t.magnitudeSquared(l),f=t.dot(l,c);if(E>1){if(f>=0)return void 0;var h=f*f;if(n=E-1,o=t.magnitudeSquared(c),i=o*n,i>h)return void 0;if(h>i){a=f*f-i,s=-f+Math.sqrt(a);var d=s/o,m=n/s;return m>d?{start:d,stop:m}:{start:m,stop:d}}var T=Math.sqrt(n/o);return{start:T,stop:T}}return 1>E?(n=E-1,o=t.magnitudeSquared(c),i=o*n,a=f*f-i,s=-f+Math.sqrt(a),{start:0,stop:s/o}):0>f?(o=t.magnitudeSquared(c),{start:0,stop:-f/o}):void 0};var v=new t,I=new t,O=new t,M=new t,L=new t,w=new a,F=new a,P=new a,D=new a,U=new a,x=new a,B=new a,b=new t,z=new t,G=new r;m.grazingAltitudeLocation=function(r,e){var o=r.origin,s=r.direction,u=e.geodeticSurfaceNormal(o,v);if(t.dot(s,u)>=0)return o;var l=n(this.rayEllipsoid(r,e)),c=e.transformPositionToScaledSpace(s,v),E=t.normalize(c,c),f=t.mostOrthogonalAxis(c,M),h=t.normalize(t.cross(f,E,I),I),m=t.normalize(t.cross(E,h,O),O),T=w;T[0]=E.x,T[1]=E.y,T[2]=E.z,T[3]=h.x,T[4]=h.y,T[5]=h.z,T[6]=m.x,T[7]=m.y,T[8]=m.z;var R=a.transpose(T,F),p=a.fromScale(e.radii,P),S=a.fromScale(e.oneOverRadii,D),_=U;_[0]=0,_[1]=-s.z,_[2]=s.y,_[3]=s.z,_[4]=0,_[5]=-s.x,_[6]=-s.y,_[7]=s.x,_[8]=0;var A,C,g=a.multiply(a.multiply(R,S,x),_,x),y=a.multiply(a.multiply(g,p,B),T,B),N=a.multiplyByVector(g,o,L),q=d(y,t.negate(N,v),0,0,1),H=q.length;if(H>0){for(var V=t.clone(t.ZERO,z),W=Number.NEGATIVE_INFINITY,Y=0;H>Y;++Y){A=a.multiplyByVector(p,a.multiplyByVector(T,q[Y],b),b);var X=t.normalize(t.subtract(A,o,M),M),k=t.dot(X,s);k>W&&(W=k,V=t.clone(A,V))}var K=e.cartesianToCartographic(V,G);return W=i.clamp(W,0,1),C=t.magnitude(t.subtract(V,o,M))*Math.sqrt(1-W*W),C=l?-C:C,K.height=C,e.cartographicToCartesian(K,new t)}return void 0};var q=new t;return m.lineSegmentPlane=function(r,e,o,a){n(a)||(a=new t);var s=t.subtract(e,r,q),u=o.normal,l=t.dot(u,s);if(Math.abs(l)<i.EPSILON6)return void 0;var c=t.dot(u,r),E=-(o.distance+c)/l;return 0>E||E>1?void 0:(t.multiplyByScalar(s,E,a),t.add(r,a,a),a)},m.trianglePlaneIntersection=function(r,e,n,o){var i=o.normal,a=o.distance,s=t.dot(i,r)+a<0,u=t.dot(i,e)+a<0,l=t.dot(i,n)+a<0,c=0;c+=s?1:0,c+=u?1:0,c+=l?1:0;var E,f;if((1===c||2===c)&&(E=new t,f=new t),1===c){if(s)return m.lineSegmentPlane(r,e,o,E),m.lineSegmentPlane(r,n,o,f),{positions:[r,e,n,E,f],indices:[0,3,4,1,2,4,1,4,3]};if(u)return m.lineSegmentPlane(e,n,o,E),m.lineSegmentPlane(e,r,o,f),{positions:[r,e,n,E,f],indices:[1,3,4,2,0,4,2,4,3]};if(l)return m.lineSegmentPlane(n,r,o,E),m.lineSegmentPlane(n,e,o,f),{positions:[r,e,n,E,f],indices:[2,3,4,0,1,4,0,4,3]}}else if(2===c){if(!s)return m.lineSegmentPlane(e,r,o,E),m.lineSegmentPlane(n,r,o,f),{positions:[r,e,n,E,f],indices:[1,2,4,1,4,3,0,3,4]};if(!u)return m.lineSegmentPlane(n,e,o,E),m.lineSegmentPlane(r,e,o,f),{positions:[r,e,n,E,f],indices:[2,0,4,2,4,3,1,3,4]};if(!l)return m.lineSegmentPlane(r,n,o,E),m.lineSegmentPlane(e,n,o,f),{positions:[r,e,n,E,f],indices:[0,1,4,0,4,3,2,3,4]}}return void 0},m}),define("Core/isArray",["./defined"],function(t){"use strict";var r=Array.isArray;return t(r)||(r=function(t){return"[object Array]"===Object.prototype.toString.call(t)}),r}),define("Core/PolylinePipeline",["./Cartesian3","./Cartographic","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./EllipsoidGeodesic","./IntersectionTests","./isArray","./Math","./Matrix4","./Plane"],function(t,r,e,n,o,i,a,s,u,l,c,E){"use strict";function f(t,r,e){var n=y;n.length=t;var o;if(r===e){for(o=0;t>o;o++)n[o]=r;return n}var i=e-r,a=i/t;for(o=0;t>o;o++){var s=r+o*a;n[o]=s}return n}function h(r,e,n,o,i,a,s,u){var l=o.scaleToGeodeticSurface(r,O),c=o.scaleToGeodeticSurface(e,M),E=d.numberOfPoints(r,e,n),h=o.cartesianToCartographic(l,N),m=o.cartesianToCartographic(c,v),T=f(E,i,a);L.setEndPoints(h,m);var R=L.surfaceDistance/E,p=u;h.height=i;var S=o.cartographicToCartesian(h,I);t.pack(S,s,p),p+=3;for(var _=1;E>_;_++){var A=L.interpolateUsingSurfaceDistance(_*R,v);A.height=T[_],S=o.cartographicToCartesian(A,I),t.pack(S,s,p),p+=3}return p}var d={};d.numberOfPoints=function(r,e,n){var o=t.distance(r,e);return Math.ceil(o/n)};var m=new r;d.extractHeights=function(t,r){for(var e=t.length,n=new Array(e),o=0;e>o;o++){var i=t[o];n[o]=r.cartesianToCartographic(i,m).height}return n};var T=new c,R=new t,p=new t,S=new E(t.ZERO,0),_=new t,A=new E(t.ZERO,0),C=new t,g=new t,y=[],N=new r,v=new r,I=new t,O=new t,M=new t,L=new a;d.wrapLongitude=function(r,o){var i=[],a=[];if(n(r)&&r.length>0){o=e(o,c.IDENTITY);var u=c.inverseTransformation(o,T),l=c.multiplyByPoint(u,t.ZERO,R),f=c.multiplyByPointAsVector(u,t.UNIT_Y,p),h=E.fromPointNormal(l,f,S),d=c.multiplyByPointAsVector(u,t.UNIT_X,_),m=E.fromPointNormal(l,d,A),y=1;i.push(t.clone(r[0]));for(var N=i[0],v=r.length,I=1;v>I;++I){var O=r[I];if(E.getPointDistance(m,N)<0||E.getPointDistance(m,O)<0){var M=s.lineSegmentPlane(N,O,h,C);if(n(M)){var L=t.multiplyByScalar(f,5e-9,g);E.getPointDistance(h,N)<0&&t.negate(L,L),i.push(t.add(M,L,new t)),a.push(y+1),t.negate(L,L),i.push(t.add(M,L,new t)),y=1}}i.push(t.clone(r[I])),y++,N=O}a.push(y)}return{positions:i,lengths:a}};var w=l.EPSILON7;return d.removeDuplicates=function(r){var e=r.length;if(2>e)return r;var n,o,i;for(n=1;e>n&&(o=r[n-1],i=r[n],!t.equalsEpsilon(o,i,w));++n);if(n===e)return r;for(var a=r.slice(0,n);e>n;++n)i=r[n],t.equalsEpsilon(o,i,w)||(a.push(t.clone(i)),o=i);return a},d.generateArc=function(r){n(r)||(r={});var o=r.positions,a=o.length,s=e(r.ellipsoid,i.WGS84),c=e(r.height,0);if(1>a)return[];if(1===a){var E=s.scaleToGeodeticSurface(o[0],O);if(0!==c){var f=s.geodeticSurfaceNormal(E,I);t.multiplyByScalar(f,c,f),t.add(E,f,E)}return[E.x,E.y,E.z]}var m=r.minDistance;if(!n(m)){var T=e(r.granularity,l.RADIANS_PER_DEGREE);m=l.chordLength(T,s.maximumRadius)}var R,p=0;for(R=0;a-1>R;R++)p+=d.numberOfPoints(o[R],o[R+1],m);var S=3*(p+1),_=new Array(S),A=0,C=u(c);for(R=0;a-1>R;R++){var g=o[R],v=o[R+1],M=C?c[R]:c,L=C?c[R+1]:c;A=h(g,v,m,s,M,L,_,A)}y.length=0;var w=o[a-1],F=s.cartesianToCartographic(w,N);F.height=C?c[a-1]:c;var P=s.cartographicToCartesian(F,I);return t.pack(P,_,S-3),_},d.generateCartesianArc=function(r){for(var e=d.generateArc(r),n=e.length/3,o=new Array(n),i=0;n>i;i++)o[i]=t.unpack(e,3*i);return o},d}),define("Core/VertexFormat",["./defaultValue","./defined","./DeveloperError","./freezeObject"],function(t,r,e,n){"use strict";var o=function(r){r=t(r,t.EMPTY_OBJECT),this.position=t(r.position,!1),this.normal=t(r.normal,!1),this.st=t(r.st,!1),this.binormal=t(r.binormal,!1),this.tangent=t(r.tangent,!1),this.color=t(r.color,!1)};return o.POSITION_ONLY=n(new o({position:!0})),o.POSITION_AND_NORMAL=n(new o({position:!0,normal:!0})),o.POSITION_NORMAL_AND_ST=n(new o({position:!0,normal:!0,st:!0})),o.POSITION_AND_ST=n(new o({position:!0,st:!0})),o.POSITION_AND_COLOR=n(new o({position:!0,color:!0})),o.ALL=n(new o({position:!0,normal:!0,st:!0,binormal:!0,tangent:!0})),o.DEFAULT=o.POSITION_NORMAL_AND_ST,o.packedLength=6,o.pack=function(r,e,n){n=t(n,0),e[n++]=r.position?1:0,e[n++]=r.normal?1:0,e[n++]=r.st?1:0,e[n++]=r.binormal?1:0,e[n++]=r.tangent?1:0,e[n++]=r.color?1:0},o.unpack=function(e,n,i){return n=t(n,0),r(i)||(i=new o),i.position=1===e[n++],i.normal=1===e[n++],i.st=1===e[n++],i.binormal=1===e[n++],i.tangent=1===e[n++],i.color=1===e[n++],i},o.clone=function(t,e){return r(t)?(r(e)||(e=new o),e.position=t.position,e.normal=t.normal,e.st=t.st,e.binormal=t.binormal,e.tangent=t.tangent,e.color=t.color,e):void 0},o}),define("Core/PolylineGeometry",["./BoundingSphere","./Cartesian3","./Color","./ComponentDatatype","./defaultValue","./defined","./DeveloperError","./Ellipsoid","./Geometry","./GeometryAttribute","./GeometryAttributes","./GeometryType","./IndexDatatype","./Math","./PolylinePipeline","./PrimitiveType","./VertexFormat"],function(t,r,e,n,o,i,a,s,u,l,c,E,f,h,d,m,T){"use strict";function R(t,r,n,o,i){var a=p;a.length=i;var s,u=n.red,l=n.green,c=n.blue,E=n.alpha,f=o.red,h=o.green,d=o.blue,m=o.alpha;if(e.equals(n,o)){for(s=0;i>s;s++)a[s]=e.clone(n);return a}var T=(f-u)/i,R=(h-l)/i,S=(d-c)/i,_=(m-E)/i;for(s=0;i>s;s++)a[s]=new e(u+s*T,l+s*R,c+s*S,E+s*_);return a}var p=[],S=function(t){t=o(t,o.EMPTY_OBJECT);var n=t.positions,a=t.colors,u=o(t.width,1),l=o(t.colorsPerVertex,!1);this._positions=n,this._colors=a,this._width=u,this._colorsPerVertex=l,this._vertexFormat=T.clone(o(t.vertexFormat,T.DEFAULT)),this._followSurface=o(t.followSurface,!0),this._granularity=o(t.granularity,h.RADIANS_PER_DEGREE),this._ellipsoid=s.clone(o(t.ellipsoid,s.WGS84)),this._workerName="createPolylineGeometry";
var c=1+n.length*r.packedLength;c+=i(a)?1+a.length*e.packedLength:1,this.packedLength=c+s.packedLength+T.packedLength+4};S.pack=function(t,n,a){a=o(a,0);var u,l=t._positions,c=l.length;for(n[a++]=c,u=0;c>u;++u,a+=r.packedLength)r.pack(l[u],n,a);var E=t._colors;for(c=i(E)?E.length:0,n[a++]=c,u=0;c>u;++u,a+=e.packedLength)e.pack(E[u],n,a);s.pack(t._ellipsoid,n,a),a+=s.packedLength,T.pack(t._vertexFormat,n,a),a+=T.packedLength,n[a++]=t._width,n[a++]=t._colorsPerVertex?1:0,n[a++]=t._followSurface?1:0,n[a]=t._granularity};var _=s.clone(s.UNIT_SPHERE),A=new T,C={positions:void 0,colors:void 0,ellipsoid:_,vertexFormat:A,width:void 0,colorsPerVertex:void 0,followSurface:void 0,granularity:void 0};S.unpack=function(t,n,a){n=o(n,0);var u,l=t[n++],c=new Array(l);for(u=0;l>u;++u,n+=r.packedLength)c[u]=r.unpack(t,n);l=t[n++];var E=l>0?new Array(l):void 0;for(u=0;l>u;++u,n+=e.packedLength)E[u]=e.unpack(t,n);var f=s.unpack(t,n,_);n+=s.packedLength;var h=T.unpack(t,n,A);n+=T.packedLength;var d=t[n++],m=1===t[n++],R=1===t[n++],p=t[n];return i(a)?(a._positions=c,a._colors=E,a._ellipsoid=s.clone(f,a._ellipsoid),a._vertexFormat=T.clone(h,a._vertexFormat),a._width=d,a._colorsPerVertex=m,a._followSurface=R,a._granularity=p,a):(C.positions=c,C.colors=E,C.width=d,C.colorsPerVertex=m,C.followSurface=R,C.granularity=p,new S(C))};var g=new r,y=new r,N=new r,v=new r;return S.createGeometry=function(o){var a,s,T,S=o._width,_=o._vertexFormat,A=o._colors,C=o._colorsPerVertex,I=o._followSurface,O=o._granularity,M=o._ellipsoid,L=h.chordLength(O,M.maximumRadius),w=d.removeDuplicates(o._positions),F=w.length;if(2>F)return void 0;if(I){var P=d.extractHeights(w,M);if(i(A)){var D=1;for(a=0;F-1>a;++a)D+=d.numberOfPoints(w[a],w[a+1],L);var U=new Array(D),x=0;for(a=0;F-1>a;++a){var B=w[a],b=w[a+1],z=A[a],G=d.numberOfPoints(B,b,L);if(C&&D>a){var q=A[a+1],H=R(B,b,z,q,G),V=H.length;for(s=0;V>s;++s)U[x++]=H[s]}else for(s=0;G>s;++s)U[x++]=e.clone(z)}U[x]=e.clone(A[A.length-1]),A=U,p.length=0}w=d.generateCartesianArc({positions:w,minDistance:L,ellipsoid:M,height:P})}F=w.length;var W,Y=4*F-4,X=new Float64Array(3*Y),k=new Float64Array(3*Y),K=new Float64Array(3*Y),Z=new Float32Array(2*Y),j=_.st?new Float32Array(2*Y):void 0,Q=i(A)?new Uint8Array(4*Y):void 0,J=0,$=0,tr=0,rr=0;for(s=0;F>s;++s){0===s?(W=g,r.subtract(w[0],w[1],W),r.add(w[0],W,W)):W=w[s-1],r.clone(W,N),r.clone(w[s],y),s===F-1?(W=g,r.subtract(w[F-1],w[F-2],W),r.add(w[F-1],W,W)):W=w[s+1],r.clone(W,v);var er,nr;i(Q)&&(er=0===s||C?A[s]:A[s-1],s!==F-1&&(nr=A[s]));var or=0===s?2:0,ir=s===F-1?2:4;for(T=or;ir>T;++T){r.pack(y,X,J),r.pack(N,k,J),r.pack(v,K,J),J+=3;var ar=0>T-2?-1:1;if(Z[$++]=2*(T%2)-1,Z[$++]=ar*S,_.st&&(j[tr++]=s/(F-1),j[tr++]=Math.max(Z[$-2],0)),i(Q)){var sr=2>T?er:nr;Q[rr++]=e.floatToByte(sr.red),Q[rr++]=e.floatToByte(sr.green),Q[rr++]=e.floatToByte(sr.blue),Q[rr++]=e.floatToByte(sr.alpha)}}}var ur=new c;ur.position=new l({componentDatatype:n.DOUBLE,componentsPerAttribute:3,values:X}),ur.prevPosition=new l({componentDatatype:n.DOUBLE,componentsPerAttribute:3,values:k}),ur.nextPosition=new l({componentDatatype:n.DOUBLE,componentsPerAttribute:3,values:K}),ur.expandAndWidth=new l({componentDatatype:n.FLOAT,componentsPerAttribute:2,values:Z}),_.st&&(ur.st=new l({componentDatatype:n.FLOAT,componentsPerAttribute:2,values:j})),i(Q)&&(ur.color=new l({componentDatatype:n.UNSIGNED_BYTE,componentsPerAttribute:4,values:Q,normalize:!0}));var lr=f.createTypedArray(Y,6*F-6),cr=0,Er=0,fr=F-1;for(s=0;fr>s;++s)lr[Er++]=cr,lr[Er++]=cr+2,lr[Er++]=cr+1,lr[Er++]=cr+1,lr[Er++]=cr+2,lr[Er++]=cr+3,cr+=4;return new u({attributes:ur,indices:lr,primitiveType:m.TRIANGLES,boundingSphere:t.fromPoints(w),geometryType:E.POLYLINES})},S}),define("Workers/createPolylineGeometry",["../Core/defined","../Core/Ellipsoid","../Core/PolylineGeometry"],function(t,r,e){"use strict";function n(n,o){return t(o)&&(n=e.unpack(n,o)),n._ellipsoid=r.clone(n._ellipsoid),e.createGeometry(n)}return n})}();