/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2015 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
/**
@license
mersenne-twister.js - https://gist.github.com/banksean/300494

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

!function(){define("Core/defined",[],function(){"use strict";var t=function(t){return void 0!==t};return t}),define("Core/freezeObject",["./defined"],function(t){"use strict";var e=Object.freeze;return t(e)||(e=function(t){return t}),e}),define("Core/defaultValue",["./freezeObject"],function(t){"use strict";var e=function(t,e){return void 0!==t?t:e};return e.EMPTY_OBJECT=t({}),e}),define("Core/DeveloperError",["./defined"],function(t){"use strict";var e=function(t){this.name="DeveloperError",this.message=t;var e;try{throw new Error}catch(r){e=r.stack}this.stack=e};return e.prototype.toString=function(){var e=this.name+": "+this.message;return t(this.stack)&&(e+="\n"+this.stack.toString()),e},e.throwInstantiationError=function(){throw new e("This function defines an interface and should not be called directly.")},e}),define("ThirdParty/mersenne-twister",[],function(){var t=function(t){void 0==t&&(t=(new Date).getTime()),this.N=624,this.M=397,this.MATRIX_A=2567483615,this.UPPER_MASK=2147483648,this.LOWER_MASK=2147483647,this.mt=new Array(this.N),this.mti=this.N+1,this.init_genrand(t)};return t.prototype.init_genrand=function(t){for(this.mt[0]=t>>>0,this.mti=1;this.mti<this.N;this.mti++){var t=this.mt[this.mti-1]^this.mt[this.mti-1]>>>30;this.mt[this.mti]=(1812433253*((4294901760&t)>>>16)<<16)+1812433253*(65535&t)+this.mti,this.mt[this.mti]>>>=0}},t.prototype.genrand_int32=function(){var t,e=new Array(0,this.MATRIX_A);if(this.mti>=this.N){var r;for(this.mti==this.N+1&&this.init_genrand(5489),r=0;r<this.N-this.M;r++)t=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+this.M]^t>>>1^e[1&t];for(;r<this.N-1;r++)t=this.mt[r]&this.UPPER_MASK|this.mt[r+1]&this.LOWER_MASK,this.mt[r]=this.mt[r+(this.M-this.N)]^t>>>1^e[1&t];t=this.mt[this.N-1]&this.UPPER_MASK|this.mt[0]&this.LOWER_MASK,this.mt[this.N-1]=this.mt[this.M-1]^t>>>1^e[1&t],this.mti=0}return t=this.mt[this.mti++],t^=t>>>11,t^=2636928640&t<<7,t^=4022730752&t<<15,t^=t>>>18,t>>>0},t.prototype.random=function(){return this.genrand_int32()*(1/4294967296)},t}),define("Core/Math",["../ThirdParty/mersenne-twister","./defaultValue","./defined","./DeveloperError"],function(t,e){"use strict";var r={};r.EPSILON1=.1,r.EPSILON2=.01,r.EPSILON3=.001,r.EPSILON4=1e-4,r.EPSILON5=1e-5,r.EPSILON6=1e-6,r.EPSILON7=1e-7,r.EPSILON8=1e-8,r.EPSILON9=1e-9,r.EPSILON10=1e-10,r.EPSILON11=1e-11,r.EPSILON12=1e-12,r.EPSILON13=1e-13,r.EPSILON14=1e-14,r.EPSILON15=1e-15,r.EPSILON16=1e-16,r.EPSILON17=1e-17,r.EPSILON18=1e-18,r.EPSILON19=1e-19,r.EPSILON20=1e-20,r.GRAVITATIONALPARAMETER=3986004418e5,r.SOLAR_RADIUS=6955e5,r.LUNAR_RADIUS=1737400,r.SIXTY_FOUR_KILOBYTES=65536,r.sign=function(t){return t>0?1:0>t?-1:0},r.signNotZero=function(t){return 0>t?-1:1},r.toSNorm=function(t){return Math.round(255*(.5*r.clamp(t,-1,1)+.5))},r.fromSNorm=function(t){return 2*(r.clamp(t,0,255)/255)-1},r.sinh=function(t){var e=Math.pow(Math.E,t),r=Math.pow(Math.E,-1*t);return.5*(e-r)},r.cosh=function(t){var e=Math.pow(Math.E,t),r=Math.pow(Math.E,-1*t);return.5*(e+r)},r.lerp=function(t,e,r){return(1-r)*t+r*e},r.PI=Math.PI,r.ONE_OVER_PI=1/Math.PI,r.PI_OVER_TWO=.5*Math.PI,r.PI_OVER_THREE=Math.PI/3,r.PI_OVER_FOUR=Math.PI/4,r.PI_OVER_SIX=Math.PI/6,r.THREE_PI_OVER_TWO=.5*3*Math.PI,r.TWO_PI=2*Math.PI,r.ONE_OVER_TWO_PI=1/(2*Math.PI),r.RADIANS_PER_DEGREE=Math.PI/180,r.DEGREES_PER_RADIAN=180/Math.PI,r.RADIANS_PER_ARCSECOND=r.RADIANS_PER_DEGREE/3600,r.toRadians=function(t){return t*r.RADIANS_PER_DEGREE},r.toDegrees=function(t){return t*r.DEGREES_PER_RADIAN},r.convertLongitudeRange=function(t){var e=r.TWO_PI,n=t-Math.floor(t/e)*e;return n<-Math.PI?n+e:n>=Math.PI?n-e:n},r.negativePiToPi=function(t){return r.zeroToTwoPi(t+r.PI)-r.PI},r.zeroToTwoPi=function(t){var e=r.mod(t,r.TWO_PI);return Math.abs(e)<r.EPSILON14&&Math.abs(t)>r.EPSILON14?r.TWO_PI:e},r.mod=function(t,e){return(t%e+e)%e},r.equalsEpsilon=function(t,r,n,i){i=e(i,n);var a=Math.abs(t-r);return i>=a||a<=n*Math.max(Math.abs(t),Math.abs(r))};var n=[1];r.factorial=function(t){var e=n.length;if(t>=e)for(var r=n[e-1],i=e;t>=i;i++)n.push(r*i);return n[t]},r.incrementWrap=function(t,r,n){return n=e(n,0),++t,t>r&&(t=n),t},r.isPowerOfTwo=function(t){return 0!==t&&0===(t&t-1)},r.nextPowerOfTwo=function(t){return--t,t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,t|=t>>16,++t,t},r.clamp=function(t,e,r){return e>t?e:t>r?r:t};var i=new t;return r.setRandomNumberSeed=function(e){i=new t(e)},r.nextRandomNumber=function(){return i.random()},r.acosClamped=function(t){return Math.acos(r.clamp(t,-1,1))},r.asinClamped=function(t){return Math.asin(r.clamp(t,-1,1))},r.chordLength=function(t,e){return 2*e*Math.sin(.5*t)},r}),define("Core/Cartesian2",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,i){"use strict";var a=function(e,r){this.x=t(e,0),this.y=t(r,0)};a.fromElements=function(t,r,n){return e(n)?(n.x=t,n.y=r,n):new a(t,r)},a.clone=function(t,r){return e(t)?e(r)?(r.x=t.x,r.y=t.y,r):new a(t.x,t.y):void 0},a.fromCartesian3=a.clone,a.fromCartesian4=a.clone,a.packedLength=2,a.pack=function(e,r,n){n=t(n,0),r[n++]=e.x,r[n]=e.y},a.unpack=function(r,n,i){return n=t(n,0),e(i)||(i=new a),i.x=r[n++],i.y=r[n],i},a.fromArray=a.unpack,a.maximumComponent=function(t){return Math.max(t.x,t.y)},a.minimumComponent=function(t){return Math.min(t.x,t.y)},a.minimumByComponent=function(t,e,r){return r.x=Math.min(t.x,e.x),r.y=Math.min(t.y,e.y),r},a.maximumByComponent=function(t,e,r){return r.x=Math.max(t.x,e.x),r.y=Math.max(t.y,e.y),r},a.magnitudeSquared=function(t){return t.x*t.x+t.y*t.y},a.magnitude=function(t){return Math.sqrt(a.magnitudeSquared(t))};var o=new a;a.distance=function(t,e){return a.subtract(t,e,o),a.magnitude(o)},a.distanceSquared=function(t,e){return a.subtract(t,e,o),a.magnitudeSquared(o)},a.normalize=function(t,e){var r=a.magnitude(t);return e.x=t.x/r,e.y=t.y/r,e},a.dot=function(t,e){return t.x*e.x+t.y*e.y},a.multiplyComponents=function(t,e,r){return r.x=t.x*e.x,r.y=t.y*e.y,r},a.add=function(t,e,r){return r.x=t.x+e.x,r.y=t.y+e.y,r},a.subtract=function(t,e,r){return r.x=t.x-e.x,r.y=t.y-e.y,r},a.multiplyByScalar=function(t,e,r){return r.x=t.x*e,r.y=t.y*e,r},a.divideByScalar=function(t,e,r){return r.x=t.x/e,r.y=t.y/e,r},a.negate=function(t,e){return e.x=-t.x,e.y=-t.y,e},a.abs=function(t,e){return e.x=Math.abs(t.x),e.y=Math.abs(t.y),e};var E=new a;a.lerp=function(t,e,r,n){return a.multiplyByScalar(e,r,E),n=a.multiplyByScalar(t,1-r,n),a.add(E,n,n)};var u=new a,_=new a;a.angleBetween=function(t,e){return a.normalize(t,u),a.normalize(e,_),i.acosClamped(a.dot(u,_))};var T=new a;return a.mostOrthogonalAxis=function(t,e){var r=a.normalize(t,T);return a.abs(r,r),e=r.x<=r.y?a.clone(a.UNIT_X,e):a.clone(a.UNIT_Y,e)},a.equals=function(t,r){return t===r||e(t)&&e(r)&&t.x===r.x&&t.y===r.y},a.equalsArray=function(t,e,r){return t.x===e[r]&&t.y===e[r+1]},a.equalsEpsilon=function(t,r,n,a){return t===r||e(t)&&e(r)&&i.equalsEpsilon(t.x,r.x,n,a)&&i.equalsEpsilon(t.y,r.y,n,a)},a.ZERO=n(new a(0,0)),a.UNIT_X=n(new a(1,0)),a.UNIT_Y=n(new a(0,1)),a.prototype.clone=function(t){return a.clone(this,t)},a.prototype.equals=function(t){return a.equals(this,t)},a.prototype.equalsEpsilon=function(t,e,r){return a.equalsEpsilon(this,t,e,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+")"},a}),define("Core/Cartesian3",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,i){"use strict";var a=function(e,r,n){this.x=t(e,0),this.y=t(r,0),this.z=t(n,0)};a.fromSpherical=function(r,n){e(n)||(n=new a);var i=r.clock,o=r.cone,E=t(r.magnitude,1),u=E*Math.sin(o);return n.x=u*Math.cos(i),n.y=u*Math.sin(i),n.z=E*Math.cos(o),n},a.fromElements=function(t,r,n,i){return e(i)?(i.x=t,i.y=r,i.z=n,i):new a(t,r,n)},a.clone=function(t,r){return e(t)?e(r)?(r.x=t.x,r.y=t.y,r.z=t.z,r):new a(t.x,t.y,t.z):void 0},a.fromCartesian4=a.clone,a.packedLength=3,a.pack=function(e,r,n){n=t(n,0),r[n++]=e.x,r[n++]=e.y,r[n]=e.z},a.unpack=function(r,n,i){return n=t(n,0),e(i)||(i=new a),i.x=r[n++],i.y=r[n++],i.z=r[n],i},a.fromArray=a.unpack,a.maximumComponent=function(t){return Math.max(t.x,t.y,t.z)},a.minimumComponent=function(t){return Math.min(t.x,t.y,t.z)},a.minimumByComponent=function(t,e,r){return r.x=Math.min(t.x,e.x),r.y=Math.min(t.y,e.y),r.z=Math.min(t.z,e.z),r},a.maximumByComponent=function(t,e,r){return r.x=Math.max(t.x,e.x),r.y=Math.max(t.y,e.y),r.z=Math.max(t.z,e.z),r},a.magnitudeSquared=function(t){return t.x*t.x+t.y*t.y+t.z*t.z},a.magnitude=function(t){return Math.sqrt(a.magnitudeSquared(t))};var o=new a;a.distance=function(t,e){return a.subtract(t,e,o),a.magnitude(o)},a.distanceSquared=function(t,e){return a.subtract(t,e,o),a.magnitudeSquared(o)},a.normalize=function(t,e){var r=a.magnitude(t);return e.x=t.x/r,e.y=t.y/r,e.z=t.z/r,e},a.dot=function(t,e){return t.x*e.x+t.y*e.y+t.z*e.z},a.multiplyComponents=function(t,e,r){return r.x=t.x*e.x,r.y=t.y*e.y,r.z=t.z*e.z,r},a.add=function(t,e,r){return r.x=t.x+e.x,r.y=t.y+e.y,r.z=t.z+e.z,r},a.subtract=function(t,e,r){return r.x=t.x-e.x,r.y=t.y-e.y,r.z=t.z-e.z,r},a.multiplyByScalar=function(t,e,r){return r.x=t.x*e,r.y=t.y*e,r.z=t.z*e,r},a.divideByScalar=function(t,e,r){return r.x=t.x/e,r.y=t.y/e,r.z=t.z/e,r},a.negate=function(t,e){return e.x=-t.x,e.y=-t.y,e.z=-t.z,e},a.abs=function(t,e){return e.x=Math.abs(t.x),e.y=Math.abs(t.y),e.z=Math.abs(t.z),e};var E=new a;a.lerp=function(t,e,r,n){return a.multiplyByScalar(e,r,E),n=a.multiplyByScalar(t,1-r,n),a.add(E,n,n)};var u=new a,_=new a;a.angleBetween=function(t,e){a.normalize(t,u),a.normalize(e,_);var r=a.dot(u,_),n=a.magnitude(a.cross(u,_,u));return Math.atan2(n,r)};var T=new a;a.mostOrthogonalAxis=function(t,e){var r=a.normalize(t,T);return a.abs(r,r),e=r.x<=r.y?r.x<=r.z?a.clone(a.UNIT_X,e):a.clone(a.UNIT_Z,e):r.y<=r.z?a.clone(a.UNIT_Y,e):a.clone(a.UNIT_Z,e)},a.equals=function(t,r){return t===r||e(t)&&e(r)&&t.x===r.x&&t.y===r.y&&t.z===r.z},a.equalsArray=function(t,e,r){return t.x===e[r]&&t.y===e[r+1]&&t.z===e[r+2]},a.equalsEpsilon=function(t,r,n,a){return t===r||e(t)&&e(r)&&i.equalsEpsilon(t.x,r.x,n,a)&&i.equalsEpsilon(t.y,r.y,n,a)&&i.equalsEpsilon(t.z,r.z,n,a)},a.cross=function(t,e,r){var n=t.x,i=t.y,a=t.z,o=e.x,E=e.y,u=e.z,_=i*u-a*E,T=a*o-n*u,s=n*E-i*o;return r.x=_,r.y=T,r.z=s,r},a.fromDegrees=function(t,e,r,n,o){var E=i.toRadians(t),u=i.toRadians(e);return a.fromRadians(E,u,r,n,o)};var s=new a,c=new a,R=new a(40680631590769,40680631590769,40408299984661.445);return a.fromRadians=function(r,n,i,o,E){i=t(i,0);var u=e(o)?o.radiiSquared:R,_=Math.cos(n);s.x=_*Math.cos(r),s.y=_*Math.sin(r),s.z=Math.sin(n),s=a.normalize(s,s),a.multiplyComponents(u,s,c);var T=Math.sqrt(a.dot(s,c));return c=a.divideByScalar(c,T,c),s=a.multiplyByScalar(s,i,s),e(E)||(E=new a),a.add(c,s,E)},a.fromDegreesArray=function(t,e,r){for(var n=new Array(t.length),o=0;o<t.length;o++)n[o]=i.toRadians(t[o]);return a.fromRadiansArray(n,e,r)},a.fromRadiansArray=function(t,r,n){var i=t.length;e(n)?n.length=i/2:n=new Array(i/2);for(var o=0;i>o;o+=2){var E=t[o],u=t[o+1];n[o/2]=a.fromRadians(E,u,0,r,n[o/2])}return n},a.fromDegreesArrayHeights=function(t,e,r){for(var n=new Array(t.length),o=0;o<t.length;o+=3)n[o]=i.toRadians(t[o]),n[o+1]=i.toRadians(t[o+1]),n[o+2]=t[o+2];return a.fromRadiansArrayHeights(n,e,r)},a.fromRadiansArrayHeights=function(t,r,n){var i=t.length;e(n)?n.length=i/3:n=new Array(i/3);for(var o=0;i>o;o+=3){var E=t[o],u=t[o+1],_=t[o+2];n[o/3]=a.fromRadians(E,u,_,r,n[o/3])}return n},a.ZERO=n(new a(0,0,0)),a.UNIT_X=n(new a(1,0,0)),a.UNIT_Y=n(new a(0,1,0)),a.UNIT_Z=n(new a(0,0,1)),a.prototype.clone=function(t){return a.clone(this,t)},a.prototype.equals=function(t){return a.equals(this,t)},a.prototype.equalsEpsilon=function(t,e,r){return a.equalsEpsilon(this,t,e,r)},a.prototype.toString=function(){return"("+this.x+", "+this.y+", "+this.z+")"},a}),define("Core/AttributeCompression",["./Cartesian2","./Cartesian3","./defined","./DeveloperError","./Math"],function(t,e,r,n,i){"use strict";var a={};a.octEncode=function(t,e){if(e.x=t.x/(Math.abs(t.x)+Math.abs(t.y)+Math.abs(t.z)),e.y=t.y/(Math.abs(t.x)+Math.abs(t.y)+Math.abs(t.z)),t.z<0){var r=e.x,n=e.y;e.x=(1-Math.abs(n))*i.signNotZero(r),e.y=(1-Math.abs(r))*i.signNotZero(n)}return e.x=i.toSNorm(e.x),e.y=i.toSNorm(e.y),e},a.octDecode=function(t,r,n){if(n.x=i.fromSNorm(t),n.y=i.fromSNorm(r),n.z=1-(Math.abs(n.x)+Math.abs(n.y)),n.z<0){var a=n.x;n.x=(1-Math.abs(n.y))*i.signNotZero(a),n.y=(1-Math.abs(a))*i.signNotZero(n.y)}return e.normalize(n,n)},a.octPackFloat=function(t){return 256*t.x+t.y};var o=new t;return a.octEncodeFloat=function(t){return a.octEncode(t,o),a.octPackFloat(o)},a.octDecodeFloat=function(t,e){var r=t/256,n=Math.floor(r),i=256*(r-n);return a.octDecode(n,i,e)},a.octPack=function(t,e,r,n){var i=a.octEncodeFloat(t),E=a.octEncodeFloat(e),u=a.octEncode(r,o);return n.x=65536*u.x+i,n.y=65536*u.y+E,n},a.octUnpack=function(t,e,r,n){var i=t.x/65536,o=Math.floor(i),E=65536*(i-o);i=t.y/65536;var u=Math.floor(i),_=65536*(i-u);a.octDecodeFloat(E,e),a.octDecodeFloat(_,r),a.octDecode(o,u,n)},a.compressTextureCoordinates=function(t){var e=1===t.x?4095:0|4096*t.x,r=1===t.y?4095:0|4096*t.y;return 4096*e+r},a.decompressTextureCoordinates=function(t,e){var r=t/4096;return e.x=Math.floor(r)/4096,e.y=r-Math.floor(r),e},a}),define("Core/Cartographic",["./defaultValue","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,i){"use strict";var a=function(e,r,n){this.longitude=t(e,0),this.latitude=t(r,0),this.height=t(n,0)};return a.fromRadians=function(r,n,i,o){return i=t(i,0),e(o)?(o.longitude=r,o.latitude=n,o.height=i,o):new a(r,n,i)},a.fromDegrees=function(t,e,r,n){return t=i.toRadians(t),e=i.toRadians(e),a.fromRadians(t,e,r,n)},a.clone=function(t,r){return e(t)?e(r)?(r.longitude=t.longitude,r.latitude=t.latitude,r.height=t.height,r):new a(t.longitude,t.latitude,t.height):void 0},a.equals=function(t,r){return t===r||e(t)&&e(r)&&t.longitude===r.longitude&&t.latitude===r.latitude&&t.height===r.height},a.equalsEpsilon=function(t,r,n){return t===r||e(t)&&e(r)&&Math.abs(t.longitude-r.longitude)<=n&&Math.abs(t.latitude-r.latitude)<=n&&Math.abs(t.height-r.height)<=n},a.ZERO=n(new a(0,0,0)),a.prototype.clone=function(t){return a.clone(this,t)},a.prototype.equals=function(t){return a.equals(this,t)},a.prototype.equalsEpsilon=function(t,e){return a.equalsEpsilon(this,t,e)},a.prototype.toString=function(){return"("+this.longitude+", "+this.latitude+", "+this.height+")"},a}),define("Core/defineProperties",["./defined"],function(t){"use strict";var e=function(){try{return"x"in Object.defineProperty({},"x",{})}catch(t){return!1}}(),r=Object.defineProperties;return e&&t(r)||(r=function(t){return t}),r}),define("Core/Ellipsoid",["./Cartesian3","./Cartographic","./defaultValue","./defined","./defineProperties","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,i,a,o,E){"use strict";function u(e,n,i,a){n=r(n,0),i=r(i,0),a=r(a,0),e._radii=new t(n,i,a),e._radiiSquared=new t(n*n,i*i,a*a),e._radiiToTheFourth=new t(n*n*n*n,i*i*i*i,a*a*a*a),e._oneOverRadii=new t(0===n?0:1/n,0===i?0:1/i,0===a?0:1/a),e._oneOverRadiiSquared=new t(0===n?0:1/(n*n),0===i?0:1/(i*i),0===a?0:1/(a*a)),e._minimumRadius=Math.min(n,i,a),e._maximumRadius=Math.max(n,i,a),e._centerToleranceSquared=E.EPSILON1}var _=function(t,e,r){this._radii=void 0,this._radiiSquared=void 0,this._radiiToTheFourth=void 0,this._oneOverRadii=void 0,this._oneOverRadiiSquared=void 0,this._minimumRadius=void 0,this._maximumRadius=void 0,this._centerToleranceSquared=void 0,u(this,t,e,r)};i(_.prototype,{radii:{get:function(){return this._radii}},radiiSquared:{get:function(){return this._radiiSquared}},radiiToTheFourth:{get:function(){return this._radiiToTheFourth}},oneOverRadii:{get:function(){return this._oneOverRadii}},oneOverRadiiSquared:{get:function(){return this._oneOverRadiiSquared}},minimumRadius:{get:function(){return this._minimumRadius}},maximumRadius:{get:function(){return this._maximumRadius}}}),_.clone=function(e,r){if(!n(e))return void 0;var i=e._radii;return n(r)?(t.clone(i,r._radii),t.clone(e._radiiSquared,r._radiiSquared),t.clone(e._radiiToTheFourth,r._radiiToTheFourth),t.clone(e._oneOverRadii,r._oneOverRadii),t.clone(e._oneOverRadiiSquared,r._oneOverRadiiSquared),r._minimumRadius=e._minimumRadius,r._maximumRadius=e._maximumRadius,r._centerToleranceSquared=e._centerToleranceSquared,r):new _(i.x,i.y,i.z)},_.fromCartesian3=function(t,e){return n(e)||(e=new _),n(t)?(u(e,t.x,t.y,t.z),e):e},_.WGS84=o(new _(6378137,6378137,6356752.314245179)),_.UNIT_SPHERE=o(new _(1,1,1)),_.MOON=o(new _(E.LUNAR_RADIUS,E.LUNAR_RADIUS,E.LUNAR_RADIUS)),_.prototype.clone=function(t){return _.clone(this,t)},_.packedLength=t.packedLength,_.pack=function(e,n,i){i=r(i,0),t.pack(e._radii,n,i)},_.unpack=function(e,n,i){n=r(n,0);var a=t.unpack(e,n);return _.fromCartesian3(a,i)},_.prototype.geocentricSurfaceNormal=t.normalize,_.prototype.geodeticSurfaceNormalCartographic=function(e,r){var i=e.longitude,a=e.latitude,o=Math.cos(a),E=o*Math.cos(i),u=o*Math.sin(i),_=Math.sin(a);return n(r)||(r=new t),r.x=E,r.y=u,r.z=_,t.normalize(r,r)},_.prototype.geodeticSurfaceNormal=function(e,r){return n(r)||(r=new t),r=t.multiplyComponents(e,this._oneOverRadiiSquared,r),t.normalize(r,r)};var T=new t,s=new t;_.prototype.cartographicToCartesian=function(e,r){var i=T,a=s;this.geodeticSurfaceNormalCartographic(e,i),t.multiplyComponents(this._radiiSquared,i,a);var o=Math.sqrt(t.dot(i,a));return t.divideByScalar(a,o,a),t.multiplyByScalar(i,e.height,i),n(r)||(r=new t),t.add(a,i,r)},_.prototype.cartographicArrayToCartesianArray=function(t,e){var r=t.length;n(e)?e.length=r:e=new Array(r);for(var i=0;r>i;i++)e[i]=this.cartographicToCartesian(t[i],e[i]);return e};var c=new t,R=new t,A=new t;_.prototype.cartesianToCartographic=function(r,i){var a=this.scaleToGeodeticSurface(r,R);if(!n(a))return void 0;var o=this.geodeticSurfaceNormal(a,c),u=t.subtract(r,a,A),_=Math.atan2(o.y,o.x),T=Math.asin(o.z),s=E.sign(t.dot(u,r))*t.magnitude(u);return n(i)?(i.longitude=_,i.latitude=T,i.height=s,i):new e(_,T,s)},_.prototype.cartesianArrayToCartographicArray=function(t,e){var r=t.length;n(e)?e.length=r:e=new Array(r);for(var i=0;r>i;++i)e[i]=this.cartesianToCartographic(t[i],e[i]);return e};var h=new t,N=new t;return _.prototype.scaleToGeodeticSurface=function(e,r){var i=e.x,a=e.y,o=e.z,u=this._oneOverRadii,_=u.x,T=u.y,s=u.z,c=i*i*_*_,R=a*a*T*T,A=o*o*s*s,d=c+R+A,S=Math.sqrt(1/d),I=t.multiplyByScalar(e,S,h);if(d<this._centerToleranceSquared)return isFinite(S)?t.clone(I,r):void 0;var f=this._oneOverRadiiSquared,l=f.x,m=f.y,M=f.z,y=N;y.x=2*I.x*l,y.y=2*I.y*m,y.z=2*I.z*M;var O,C,L,U,P,p,D,x,g,v,F,B=(1-S)*t.magnitude(e)/(.5*t.magnitude(y)),w=0;do{B-=w,L=1/(1+B*l),U=1/(1+B*m),P=1/(1+B*M),p=L*L,D=U*U,x=P*P,g=p*L,v=D*U,F=x*P,O=c*p+R*D+A*x-1,C=c*g*l+R*v*m+A*F*M;var z=-2*C;w=O/z}while(Math.abs(O)>E.EPSILON12);return n(r)?(r.x=i*L,r.y=a*U,r.z=o*P,r):new t(i*L,a*U,o*P)},_.prototype.scaleToGeocentricSurface=function(e,r){n(r)||(r=new t);var i=e.x,a=e.y,o=e.z,E=this._oneOverRadiiSquared,u=1/Math.sqrt(i*i*E.x+a*a*E.y+o*o*E.z);return t.multiplyByScalar(e,u,r)},_.prototype.transformPositionToScaledSpace=function(e,r){return n(r)||(r=new t),t.multiplyComponents(e,this._oneOverRadii,r)},_.prototype.transformPositionFromScaledSpace=function(e,r){return n(r)||(r=new t),t.multiplyComponents(e,this._radii,r)},_.prototype.equals=function(e){return this===e||n(e)&&t.equals(this._radii,e._radii)},_.prototype.toString=function(){return this._radii.toString()},_}),define("Renderer/WebGLConstants",["../Core/freezeObject"],function(t){"use strict";var e={DEPTH_BUFFER_BIT:256,STENCIL_BUFFER_BIT:1024,COLOR_BUFFER_BIT:16384,POINTS:0,LINES:1,LINE_LOOP:2,LINE_STRIP:3,TRIANGLES:4,TRIANGLE_STRIP:5,TRIANGLE_FAN:6,ZERO:0,ONE:1,SRC_COLOR:768,ONE_MINUS_SRC_COLOR:769,SRC_ALPHA:770,ONE_MINUS_SRC_ALPHA:771,DST_ALPHA:772,ONE_MINUS_DST_ALPHA:773,DST_COLOR:774,ONE_MINUS_DST_COLOR:775,SRC_ALPHA_SATURATE:776,FUNC_ADD:32774,BLEND_EQUATION:32777,BLEND_EQUATION_RGB:32777,BLEND_EQUATION_ALPHA:34877,FUNC_SUBTRACT:32778,FUNC_REVERSE_SUBTRACT:32779,BLEND_DST_RGB:32968,BLEND_SRC_RGB:32969,BLEND_DST_ALPHA:32970,BLEND_SRC_ALPHA:32971,CONSTANT_COLOR:32769,ONE_MINUS_CONSTANT_COLOR:32770,CONSTANT_ALPHA:32771,ONE_MINUS_CONSTANT_ALPHA:32772,BLEND_COLOR:32773,ARRAY_BUFFER:34962,ELEMENT_ARRAY_BUFFER:34963,ARRAY_BUFFER_BINDING:34964,ELEMENT_ARRAY_BUFFER_BINDING:34965,STREAM_DRAW:35040,STATIC_DRAW:35044,DYNAMIC_DRAW:35048,BUFFER_SIZE:34660,BUFFER_USAGE:34661,CURRENT_VERTEX_ATTRIB:34342,FRONT:1028,BACK:1029,FRONT_AND_BACK:1032,CULL_FACE:2884,BLEND:3042,DITHER:3024,STENCIL_TEST:2960,DEPTH_TEST:2929,SCISSOR_TEST:3089,POLYGON_OFFSET_FILL:32823,SAMPLE_ALPHA_TO_COVERAGE:32926,SAMPLE_COVERAGE:32928,NO_ERROR:0,INVALID_ENUM:1280,INVALID_VALUE:1281,INVALID_OPERATION:1282,OUT_OF_MEMORY:1285,CW:2304,CCW:2305,LINE_WIDTH:2849,ALIASED_POINT_SIZE_RANGE:33901,ALIASED_LINE_WIDTH_RANGE:33902,CULL_FACE_MODE:2885,FRONT_FACE:2886,DEPTH_RANGE:2928,DEPTH_WRITEMASK:2930,DEPTH_CLEAR_VALUE:2931,DEPTH_FUNC:2932,STENCIL_CLEAR_VALUE:2961,STENCIL_FUNC:2962,STENCIL_FAIL:2964,STENCIL_PASS_DEPTH_FAIL:2965,STENCIL_PASS_DEPTH_PASS:2966,STENCIL_REF:2967,STENCIL_VALUE_MASK:2963,STENCIL_WRITEMASK:2968,STENCIL_BACK_FUNC:34816,STENCIL_BACK_FAIL:34817,STENCIL_BACK_PASS_DEPTH_FAIL:34818,STENCIL_BACK_PASS_DEPTH_PASS:34819,STENCIL_BACK_REF:36003,STENCIL_BACK_VALUE_MASK:36004,STENCIL_BACK_WRITEMASK:36005,VIEWPORT:2978,SCISSOR_BOX:3088,COLOR_CLEAR_VALUE:3106,COLOR_WRITEMASK:3107,UNPACK_ALIGNMENT:3317,PACK_ALIGNMENT:3333,MAX_TEXTURE_SIZE:3379,MAX_VIEWPORT_DIMS:3386,SUBPIXEL_BITS:3408,RED_BITS:3410,GREEN_BITS:3411,BLUE_BITS:3412,ALPHA_BITS:3413,DEPTH_BITS:3414,STENCIL_BITS:3415,POLYGON_OFFSET_UNITS:10752,POLYGON_OFFSET_FACTOR:32824,TEXTURE_BINDING_2D:32873,SAMPLE_BUFFERS:32936,SAMPLES:32937,SAMPLE_COVERAGE_VALUE:32938,SAMPLE_COVERAGE_INVERT:32939,COMPRESSED_TEXTURE_FORMATS:34467,DONT_CARE:4352,FASTEST:4353,NICEST:4354,GENERATE_MIPMAP_HINT:33170,BYTE:5120,UNSIGNED_BYTE:5121,SHORT:5122,UNSIGNED_SHORT:5123,INT:5124,UNSIGNED_INT:5125,FLOAT:5126,DEPTH_COMPONENT:6402,ALPHA:6406,RGB:6407,RGBA:6408,LUMINANCE:6409,LUMINANCE_ALPHA:6410,UNSIGNED_SHORT_4_4_4_4:32819,UNSIGNED_SHORT_5_5_5_1:32820,UNSIGNED_SHORT_5_6_5:33635,FRAGMENT_SHADER:35632,VERTEX_SHADER:35633,MAX_VERTEX_ATTRIBS:34921,MAX_VERTEX_UNIFORM_VECTORS:36347,MAX_VARYING_VECTORS:36348,MAX_COMBINED_TEXTURE_IMAGE_UNITS:35661,MAX_VERTEX_TEXTURE_IMAGE_UNITS:35660,MAX_TEXTURE_IMAGE_UNITS:34930,MAX_FRAGMENT_UNIFORM_VECTORS:36349,SHADER_TYPE:35663,DELETE_STATUS:35712,LINK_STATUS:35714,VALIDATE_STATUS:35715,ATTACHED_SHADERS:35717,ACTIVE_UNIFORMS:35718,ACTIVE_ATTRIBUTES:35721,SHADING_LANGUAGE_VERSION:35724,CURRENT_PROGRAM:35725,NEVER:512,LESS:513,EQUAL:514,LEQUAL:515,GREATER:516,NOTEQUAL:517,GEQUAL:518,ALWAYS:519,KEEP:7680,REPLACE:7681,INCR:7682,DECR:7683,INVERT:5386,INCR_WRAP:34055,DECR_WRAP:34056,VENDOR:7936,RENDERER:7937,VERSION:7938,NEAREST:9728,LINEAR:9729,NEAREST_MIPMAP_NEAREST:9984,LINEAR_MIPMAP_NEAREST:9985,NEAREST_MIPMAP_LINEAR:9986,LINEAR_MIPMAP_LINEAR:9987,TEXTURE_MAG_FILTER:10240,TEXTURE_MIN_FILTER:10241,TEXTURE_WRAP_S:10242,TEXTURE_WRAP_T:10243,TEXTURE_2D:3553,TEXTURE:5890,TEXTURE_CUBE_MAP:34067,TEXTURE_BINDING_CUBE_MAP:34068,TEXTURE_CUBE_MAP_POSITIVE_X:34069,TEXTURE_CUBE_MAP_NEGATIVE_X:34070,TEXTURE_CUBE_MAP_POSITIVE_Y:34071,TEXTURE_CUBE_MAP_NEGATIVE_Y:34072,TEXTURE_CUBE_MAP_POSITIVE_Z:34073,TEXTURE_CUBE_MAP_NEGATIVE_Z:34074,MAX_CUBE_MAP_TEXTURE_SIZE:34076,TEXTURE0:33984,TEXTURE1:33985,TEXTURE2:33986,TEXTURE3:33987,TEXTURE4:33988,TEXTURE5:33989,TEXTURE6:33990,TEXTURE7:33991,TEXTURE8:33992,TEXTURE9:33993,TEXTURE10:33994,TEXTURE11:33995,TEXTURE12:33996,TEXTURE13:33997,TEXTURE14:33998,TEXTURE15:33999,TEXTURE16:34e3,TEXTURE17:34001,TEXTURE18:34002,TEXTURE19:34003,TEXTURE20:34004,TEXTURE21:34005,TEXTURE22:34006,TEXTURE23:34007,TEXTURE24:34008,TEXTURE25:34009,TEXTURE26:34010,TEXTURE27:34011,TEXTURE28:34012,TEXTURE29:34013,TEXTURE30:34014,TEXTURE31:34015,ACTIVE_TEXTURE:34016,REPEAT:10497,CLAMP_TO_EDGE:33071,MIRRORED_REPEAT:33648,FLOAT_VEC2:35664,FLOAT_VEC3:35665,FLOAT_VEC4:35666,INT_VEC2:35667,INT_VEC3:35668,INT_VEC4:35669,BOOL:35670,BOOL_VEC2:35671,BOOL_VEC3:35672,BOOL_VEC4:35673,FLOAT_MAT2:35674,FLOAT_MAT3:35675,FLOAT_MAT4:35676,SAMPLER_2D:35678,SAMPLER_CUBE:35680,VERTEX_ATTRIB_ARRAY_ENABLED:34338,VERTEX_ATTRIB_ARRAY_SIZE:34339,VERTEX_ATTRIB_ARRAY_STRIDE:34340,VERTEX_ATTRIB_ARRAY_TYPE:34341,VERTEX_ATTRIB_ARRAY_NORMALIZED:34922,VERTEX_ATTRIB_ARRAY_POINTER:34373,VERTEX_ATTRIB_ARRAY_BUFFER_BINDING:34975,IMPLEMENTATION_COLOR_READ_TYPE:35738,IMPLEMENTATION_COLOR_READ_FORMAT:35739,COMPILE_STATUS:35713,LOW_FLOAT:36336,MEDIUM_FLOAT:36337,HIGH_FLOAT:36338,LOW_INT:36339,MEDIUM_INT:36340,HIGH_INT:36341,FRAMEBUFFER:36160,RENDERBUFFER:36161,RGBA4:32854,RGB5_A1:32855,RGB565:36194,DEPTH_COMPONENT16:33189,STENCIL_INDEX:6401,STENCIL_INDEX8:36168,DEPTH_STENCIL:34041,RENDERBUFFER_WIDTH:36162,RENDERBUFFER_HEIGHT:36163,RENDERBUFFER_INTERNAL_FORMAT:36164,RENDERBUFFER_RED_SIZE:36176,RENDERBUFFER_GREEN_SIZE:36177,RENDERBUFFER_BLUE_SIZE:36178,RENDERBUFFER_ALPHA_SIZE:36179,RENDERBUFFER_DEPTH_SIZE:36180,RENDERBUFFER_STENCIL_SIZE:36181,FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE:36048,FRAMEBUFFER_ATTACHMENT_OBJECT_NAME:36049,FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL:36050,FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE:36051,COLOR_ATTACHMENT0:36064,DEPTH_ATTACHMENT:36096,STENCIL_ATTACHMENT:36128,DEPTH_STENCIL_ATTACHMENT:33306,NONE:0,FRAMEBUFFER_COMPLETE:36053,FRAMEBUFFER_INCOMPLETE_ATTACHMENT:36054,FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT:36055,FRAMEBUFFER_INCOMPLETE_DIMENSIONS:36057,FRAMEBUFFER_UNSUPPORTED:36061,FRAMEBUFFER_BINDING:36006,RENDERBUFFER_BINDING:36007,MAX_RENDERBUFFER_SIZE:34024,INVALID_FRAMEBUFFER_OPERATION:1286,UNPACK_FLIP_Y_WEBGL:37440,UNPACK_PREMULTIPLY_ALPHA_WEBGL:37441,CONTEXT_LOST_WEBGL:37442,UNPACK_COLORSPACE_CONVERSION_WEBGL:37443,BROWSER_DEFAULT_WEBGL:37444,UNSIGNED_INT_24_8_WEBGL:34042,DOUBLE:5130};return t(e)}),define("Core/IndexDatatype",["../Renderer/WebGLConstants","./defined","./DeveloperError","./freezeObject","./Math"],function(t,e,r,n,i){"use strict";var a={UNSIGNED_BYTE:t.UNSIGNED_BYTE,UNSIGNED_SHORT:t.UNSIGNED_SHORT,UNSIGNED_INT:t.UNSIGNED_INT};return a.getSizeInBytes=function(t){switch(t){case a.UNSIGNED_BYTE:return Uint8Array.BYTES_PER_ELEMENT;case a.UNSIGNED_SHORT:return Uint16Array.BYTES_PER_ELEMENT;case a.UNSIGNED_INT:return Uint32Array.BYTES_PER_ELEMENT}},a.validate=function(t){return e(t)&&(t===a.UNSIGNED_BYTE||t===a.UNSIGNED_SHORT||t===a.UNSIGNED_INT)},a.createTypedArray=function(t,e){return t>i.SIXTY_FOUR_KILOBYTES?new Uint32Array(e):new Uint16Array(e)},a.createTypedArrayFromArrayBuffer=function(t,e,r,n){return t>i.SIXTY_FOUR_KILOBYTES?new Uint32Array(e,r,n):new Uint16Array(e,r,n)},n(a)}),define("Core/formatError",["./defined"],function(t){"use strict";var e=function(e){var r,n=e.name,i=e.message;r=t(n)&&t(i)?n+": "+i:e.toString();var a=e.stack;return t(a)&&(r+="\n"+a),r};return e}),define("Workers/createTaskProcessorWorker",["../Core/defaultValue","../Core/defined","../Core/formatError"],function(t,e,r){"use strict";var n=function(n){var i,a=[],o={id:void 0,result:void 0,error:void 0};return function(E){var u=E.data;a.length=0,o.id=u.id,o.error=void 0,o.result=void 0;try{o.result=n(u.parameters,a)}catch(_){o.error=_ instanceof Error?{name:_.name,message:_.message,stack:_.stack}:_}e(i)||(i=t(self.webkitPostMessage,self.postMessage)),u.canTransferArrayBuffer||(a.length=0);try{i(o,a)}catch(_){o.result=void 0,o.error="postMessage failed with error: "+r(_)+"\n  with responseMessage: "+JSON.stringify(o),i(o)}}};return n}),define("Workers/createVerticesFromQuantizedTerrainMesh",["../Core/AttributeCompression","../Core/Cartesian2","../Core/Cartesian3","../Core/Cartographic","../Core/defined","../Core/Ellipsoid","../Core/IndexDatatype","../Core/Math","./createTaskProcessorWorker"],function(t,e,r,n,i,a,o,E,u){"use strict";function _(e,r){var n=e.quantizedVertices,u=n.length/3,_=e.octEncodedNormals,m=e.westIndices.length+e.eastIndices.length+e.southIndices.length+e.northIndices.length,M=e.minimumHeight,y=e.maximumHeight,O=e.relativeToCenter,C=e.rectangle,L=C.west,U=C.south,P=C.east,p=C.north,D=a.clone(e.ellipsoid),x=n.subarray(0,u),g=n.subarray(u,2*u),v=n.subarray(2*u,3*u),F=i(_),B=6;F&&(B+=1);for(var w=new Float32Array(u*B+m*B),z=0,X=0,G=0;u>z;++z,X+=B,G+=2){var H=x[z]/s,V=g[z]/s,q=E.lerp(M,y,v[z]/s);f.longitude=E.lerp(L,P,H),f.latitude=E.lerp(U,p,V),f.height=q,D.cartographicToCartesian(f,I),w[X+c]=I.x-O.x,w[X+R]=I.y-O.y,w[X+A]=I.z-O.z,w[X+h]=q,w[X+N]=H,w[X+d]=V,F&&(l.x=_[G],l.y=_[G+1],w[X+S]=t.octPackFloat(l))}var b=Math.max(0,2*(m-4)),W=e.indices.length+3*b,Y=o.createTypedArray(u+m,W);Y.set(e.indices,0);var k=u*B,K=e.indices.length;return K=T(w,k,Y,K,e.westIndices,O,D,C,e.westSkirtHeight,!0,F),k+=e.westIndices.length*B,K=T(w,k,Y,K,e.southIndices,O,D,C,e.southSkirtHeight,!1,F),k+=e.southIndices.length*B,K=T(w,k,Y,K,e.eastIndices,O,D,C,e.eastSkirtHeight,!1,F),k+=e.eastIndices.length*B,K=T(w,k,Y,K,e.northIndices,O,D,C,e.northSkirtHeight,!0,F),k+=e.northIndices.length*B,r.push(w.buffer,Y.buffer),{vertices:w.buffer,indices:Y.buffer}}function T(t,e,n,i,a,o,u,_,T,s,c){var R,A,l,m=6;c&&(m+=1),s?(R=a.length-1,A=-1,l=-1):(R=0,A=a.length,l=1);var M=-1,y=e/m,O=_.north,C=_.south,L=_.east,U=_.west;U>L&&(L+=E.TWO_PI);for(var P=R;P!==A;P+=l){var p=a[P],D=p*m,x=t[D+N],g=t[D+d],v=t[D+h];f.longitude=E.lerp(U,L,x),f.latitude=E.lerp(C,O,g),f.height=v-T;var F=u.cartographicToCartesian(f,I);r.subtract(F,o,F),t[e++]=F.x,t[e++]=F.y,t[e++]=F.z,t[e++]=f.height,t[e++]=x,t[e++]=g,c&&(t[e++]=t[D+S]),-1!==M&&(n[i++]=M,n[i++]=y-1,n[i++]=p,n[i++]=y-1,n[i++]=y,n[i++]=p),M=p,++y}return i}var s=32767,c=0,R=1,A=2,h=3,N=4,d=5,S=6,I=new r,f=new n,l=new e;return u(_)})}();